//----------------------------------------------------------------------//
// NyanFi																//
//  eLXgrA[													//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <algorithm>
#include <System.NetEncoding.hpp>
#include <IdURI.hpp>
#include <Vcl.Clipbrd.hpp>
#include <RegularExpressions.hpp>
#include "htmconv.h"
#include "usr_mmfile.h"
#include "usr_xd2tx.h"
#include "usr_excmd.h"
#include "usr_highlight.h"
#include "UserFunc.h"
#include "FuncDlg.h"
#include "FileInfDlg.h"
#include "ChInfFrm.h"
#include "GraphFrm.h"
#include "CsvRecFrm.h"
#include "InspectFrm.h"
#include "BitmapFrm.h"
#include "GifView.h"
#include "ColDlg.h"
#include "InpDir.h"
#include "InpExDlg.h"
#include "ExTViewer.h"
#include "TxtViewer.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

TTxtViewer *TxtViewer;

//---------------------------------------------------------------------------
// TTxtViewer NX
//---------------------------------------------------------------------------
__fastcall TTxtViewer::TTxtViewer(
	TForm *frm,
	TPaintBox *viewbox,		//\̈
	TScrollBar *scrbar,		//XN[o[
	UsrScrollPanel *sp, 	//ƎXN[o[
	TStatusBar *stthdr,		//wb_
	TPaintBox *ruler,		//[
	TPanel *colref,			//J[\
	TPaintBox *mgn_box)		//E]pl	(default = NULL)
{
	isReady    = false;
	OwnerForm  = frm;
	isExtWnd   = OwnerForm->ClassNameIs("TExTxtViewer");

	ViewBox    = viewbox;
	ViewCanvas = ViewBox->Canvas;

	ScrBar	   = scrbar;
	ScrPanel   = sp;
	SttHeader  = stthdr;
	RulerBox   = ruler;
	ColorPanel = colref;
	MarginBox  = mgn_box;

	if (RulerBox) {
		RulerBox->OnPaint	 = onRulerPaint;
		RulerBox->OnDblClick = onRulerDblClick;
	}

	ImgBuff = new Graphics::TBitmap();

	ColBufList = new TStringList();

	TxtBufList	= new TStringList();
	TxtBufList2 = new TStringList();
	MaxLine 	= 0;

	DispLines	= new TStringList();
	MaxDispLine = 0;

	RemLnList	= new TStringList();
	RemBgnList	= new TStringList();
	RemEndList	= new TStringList();

	MMF = new MemMapFile();

	SetColor();

	BinarySize	= 0;
	BinFileSize = 0;
	TopAddress	= 0;

	BinLineRec.LineNo  = 1;
	BinLineRec.LineIdx = 0;
	BinLineRec.hasCR   = true;
	BinLineRec.topQch  = '\0';
	BinLineRec.RemPos0 = 0;
	BinLineRec.RemPos1 = 0;

	FileRec		= NULL;

	EmpComment	= true;
	EmpStrings	= true;
	EmpReserved = true;
	useEsc		= true;

	isSelected  = false;
	isText		= isBinary = false;
	isCSV		= isTSV    = false;
	isXDoc2Txt	= false;
	isHtm2Txt	= isFixedLen = false;
	isLimited	= false;
	isTail		= false;
	isContinue	= false;
	ShowRuby	= true;
	isAozora	= isLog = isClip = isIniFmt = isAwstats = isNyanTxt = false;
	isSelMode	= isBoxMode = false;
	reqCurPos	= false;

	FontHeight	= abs(ViewBox->Font->Height);
	LineHeight	= FontHeight + ViewTxtInterLn;
	HchWidth	= 0;
	LineCount	= 0;
	TabLength	= 0;
	TabWidth	= 0;
	TopXpos 	= 0;
	TopMargin	= 8;
	SortMode	= 0;
	SortCol 	= 0;

	CurPos		= Point(0, 0);
	CurHchX		= 0;
	MaxHchX 	= 80;
	MaxFoldWd	= 80;
	SelStart	= CurPos;
	SelEnd		= CurPos;
	BoxStart	= Point(0, 0);
	BoxEnd		= BoxStart;
	CsvCol		= -1;

	isRegEx 	= isCase = isMigemo = isBytes = false;
	isIncSea	= false;

	Highlight	= IniFile->ReadBoolGen(_T("FindTxtDlgHighlight"));

	ExtClicked	= false;
	Selecting	= false;
	PtInSelect  = false;
	LastFound   = false;

	LastPos		= Point(-1, -1);
	LastTop		= -1;
	LastSel 	= false;
	SelSkip 	= false;
	inh_Repaint = false;
}
//---------------------------------------------------------------------------
__fastcall TTxtViewer::~TTxtViewer()
{
	ClearDispLine();

	delete ColBufList;
	delete DispLines;
	delete ImgBuff;
	delete TxtBufList;
	delete TxtBufList2;
	delete RemLnList;
	delete RemBgnList;
	delete RemEndList;
	delete MMF;
}

//---------------------------------------------------------------------------
//⏕ʂ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::CloseAuxForm()
{
	bool closed = false;
	if (CharInfoForm->Visible) { CharInfoForm->Close();	closed = true; }
	if (CsvRecForm->Visible)   { CsvRecForm->Close();	closed = true; }
	if (BitmapForm->Visible)   { BitmapForm->Close();	closed = true; }
	if (InspectForm->Visible)  { InspectForm->Close();	closed = true; }
	if (GifViewer->Visible)    { GifViewer->Close();	closed = true; }
	return closed;
}

//---------------------------------------------------------------------------
//\sR[hǉ
//---------------------------------------------------------------------------
line_rec* __fastcall TTxtViewer::AddDispLine(UnicodeString s, int lno, int lidx)
{
	line_rec *lp = new line_rec;
	lp->LineNo	 = lno;
	lp->LineIdx  = lidx;
	lp->hasCR	 = ends_tchs(_T("\n\r"), s);
	lp->topQch	 = '\0';
	lp->RemPos0  = 0;
	lp->RemPos1  = 0;
	DispLines->AddObject(s, (TObject*)lp);
	return lp;
}

//---------------------------------------------------------------------------
//ws̕\sR[h(line_rec)擾
//---------------------------------------------------------------------------
line_rec * __fastcall TTxtViewer::get_LineRec(int idx)
{
	line_rec *lp;
	if (isBinary) {
		lp = &BinLineRec;
		lp->LineNo = (idx<MaxDispLine-1)? (TopAddress/16 + idx + 1) : -1;
	}
	else
		lp = (line_rec*)DispLines->Objects[idx];
	return lp;
}

//---------------------------------------------------------------------------
//ws̕\擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::get_DispLine(
	int idx,
	int b0,		//擾JnItZbg(oCi)@(default = 0);
	int b1)		//擾IItZbg(oCi)@(default = 15);
{
	UnicodeString lbuf;
	if (isBinary) {
		unsigned int adr = idx*16;
		if (adr<BinarySize) {
			UnicodeString abuf = " ";	//ASCII\
			for (int i=0; i<16; i++,adr++) {
				if (i==8) lbuf.UCAT_T(" ");
				if (i>=b0 && i<=b1 && adr<BinarySize) {
					unsigned char c = MMF->Bytes[adr];
					lbuf.cat_sprintf(_T("%02X "), c);
					abuf.cat_sprintf(_T("%c"), isprint(c)? c : '.');
				}
				else {
					lbuf.UCAT_T("   ");
					abuf.UCAT_T(" ");
				}
			}
			lbuf += abuf;
		}
	}
	else {
		if (idx>=0 && idx<DispLines->Count) lbuf = DispLines->Strings[idx];
	}
	return lbuf;
}

//---------------------------------------------------------------------------
void __fastcall TTxtViewer::ClearDispLine()
{
	ScrPanel->HitLines->Clear();

	for (int i=0; i<DispLines->Count; i++) delete (line_rec*)DispLines->Objects[i];
	DispLines->Clear();
	MaxDispLine = 0;

	TxtBufList2->Clear();
	FixWdList.Length = 0;
}

//---------------------------------------------------------------------------
//zF̐ݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetColor(TStringList *lst)
{
	if (!lst) return;

	color_Cursor	= read_ColorList(_T("Cursor"),		col_Cursor,		lst);
	color_selItem 	= read_ColorList(_T("selItem"),		col_selItem,	lst);
	color_fgSelItem = read_ColorList(_T("fgSelItem"),	col_fgSelItem,	lst);
	color_Folder	= read_ColorList(_T("Folder"),		col_Folder,		lst);
	color_Error		= read_ColorList(_T("Error"),		col_Error,		lst);
	color_bgView	= read_ColorList(_T("bgView"),		col_bgView,		lst);
	color_fgView	= read_ColorList(_T("fgView"),		col_fgView,		lst);
	color_Margin	= read_ColorList(_T("Margin"),		col_Margin,		lst);
	color_bgRuler	= read_ColorList(_T("bgRuler"),		col_bgRuler,	lst);
	color_fgRuler	= read_ColorList(_T("fgRuler"),		col_fgRuler,	lst);
	color_bgLineNo	= read_ColorList(_T("bgLineNo"),	col_bgLineNo,	lst);
	color_LineNo	= read_ColorList(_T("LineNo"),		col_LineNo,		lst);
	color_Mark		= read_ColorList(_T("Mark"),		col_Mark,		lst);
	color_bdrLine	= read_ColorList(_T("bdrLine"),		col_bdrLine,	lst);
	color_bdrFold	= read_ColorList(_T("bdrFold"),		col_bdrFold,	lst);
	color_bdrFixed	= read_ColorList(_T("bdrFixed"),	col_bdrFixed,	lst);
	color_Comment	= read_ColorList(_T("Comment"),		col_Comment,	lst);
	color_Strings	= read_ColorList(_T("Strings"),		col_Strings,	lst);
	color_Reserved	= read_ColorList(_T("Reserved"),	col_Reserved,	lst);
	color_Symbol	= read_ColorList(_T("Symbol"),		col_Symbol,		lst);
	color_Numeric	= read_ColorList(_T("Numeric"),		col_Numeric,	lst);
	color_fgEmpBin1 = read_ColorList(_T("fgEmpBin1"),	col_fgEmpBin1,	lst);
	color_fgEmpBin2 = read_ColorList(_T("fgEmpBin2"),	col_fgEmpBin2,	lst);
	color_fgEmpBin3 = read_ColorList(_T("fgEmpBin3"),	col_fgEmpBin3,	lst);
	color_Headline	= read_ColorList(_T("Headline"),	col_Headline,	lst);
	color_URL		= read_ColorList(_T("URL"),			col_URL,		lst);
	color_LocalLink = read_ColorList(_T("LocalLink"),	col_LocalLink,	lst);
	color_fgEmp 	= read_ColorList(_T("fgEmp"),		col_fgEmp,		lst);
	color_bgEmp 	= read_ColorList(_T("bgEmp"),		col_bgEmp,		lst);
	color_Ruby		= read_ColorList(_T("Ruby"),		col_Ruby,		lst);
	color_TAB		= read_ColorList(_T("TAB"),			col_TAB,		lst);
	color_CR		= read_ColorList(_T("CR"),			col_CR,			lst);
	color_HR		= read_ColorList(_T("HR"),			col_HR,			lst);
	color_Ctrl		= read_ColorList(_T("Ctrl"),		col_Ctrl,		lst);

	if (lst!=ColBufList) ColBufList->Assign(lst);
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetColor(UnicodeString prm)
{
	ColBufList->Clear();

	if (!USAME_TI(prm, "RS")) {
		UnicodeString fnam = to_absolute_name(prm);
		if (file_exists(fnam)) {
			std::unique_ptr<UsrIniFile> inp_file(new UsrIniFile(fnam));
			inp_file->ReadSection("Color", ColBufList);
		}
	}

	SetColor(ColBufList);
}

//---------------------------------------------------------------------------
//IvVݒɔzF𔽉f
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetOptColor()
{
	col_Cursor	  = color_Cursor;
	col_selItem   = color_selItem;
	col_fgSelItem = color_fgSelItem;
	col_Folder	  = color_Folder;
	col_Error	  = color_Error;
	col_bgView	  = color_bgView;
	col_fgView	  = color_fgView;
	col_Margin	  = color_Margin;
	col_bgRuler   = color_bgRuler;
	col_fgRuler   = color_fgRuler;
	col_bgLineNo  = color_bgLineNo;
	col_LineNo	  = color_LineNo;
	col_Mark	  = color_Mark;
	col_bdrLine   = color_bdrLine;
	col_bdrFold   = color_bdrFold;
	col_Comment   = color_Comment;
	col_Strings   = color_Strings;
	col_Reserved  = color_Reserved;
	col_Symbol	  = color_Symbol;
	col_Numeric   = color_Numeric;
	col_fgEmpBin1 = color_fgEmpBin1;
	col_fgEmpBin2 = color_fgEmpBin2;
	col_fgEmpBin3 = color_fgEmpBin3;
	col_Headline  = color_Headline;
	col_URL 	  = color_URL;
	col_LocalLink = color_LocalLink;
	col_fgEmp	  = color_fgEmp;
	col_bgEmp	  = color_bgEmp;
	col_Ruby	  = color_Ruby;
	col_TAB 	  = color_TAB;
	col_CR		  = color_CR;
	col_HR		  = color_HR;
	col_Ctrl	  = color_Ctrl;

	for (int i=0; i<ColBufList->Count; i++) {
		int idx = ColorList->IndexOfName(ColBufList->Names[i]);
		if (idx!=-1) ColorList->Strings[idx] = ColBufList->Strings[i];
	}
}

//---------------------------------------------------------------------------
//gbN̐ݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetMetric(bool set_hi)
{
	isFitWin = isExtWnd? true : ViewFoldFitWin;

	IsIrregFont = IsIrregularFont(ViewBox->Font);

	//Y[̍sԒ
	if (ViewBox->Font->Size != useFontSize) ViewTxtInterLn *= (1.0 * ViewBox->Font->Size/useFontSize);

	ViewCanvas->Font->Assign(ViewBox->Font);
	FontHeight = abs(ViewCanvas->Font->Height);
	LineHeight = FontHeight + ViewTxtInterLn;
	LineCount  = ViewBox->ClientHeight / LineHeight - 1;

	if (TabLength==0) TabLength = get_ViewTabWidth(get_extension(FileName));
	HchWidth   = get_TextWidth(ViewCanvas, "W", IsIrregFont);
	TabWidth   = TabLength * HchWidth;

	LeftMargin = isExtWnd? 0 : ViewLeftMargin;
	TopXpos    = LeftMargin + MARK_WIDTH;

	if		(isBinary)   TopXpos += (HchWidth * (get_AddrStr(BinFileSize - 1).Length() + 2));
	else if (ShowLineNo) TopXpos += (HchWidth * 8);

	TopMargin = HchWidth;

	//XN[o[ʒu̐ݒ
	if (MarginBox) {
		MaxFoldWd = (ViewBox->ClientWidth + MarginBox->Width - HchWidth*2 - TopXpos) / HchWidth;
		//܂Ԃʒu
		if (ScrBarToFoldPos && (isBinary || (!isFitWin && ViewFoldWidth>0))) {
			int w = ViewBox->ClientWidth + MarginBox->Width;
			w -= (TopXpos + ((isBinary? MAX_BIN_HCH_X : ViewFoldWidth) + 2) * HchWidth);
			if (w>=0) MarginBox->Width = w;
		}
		//E[
		else {
			MarginBox->Width = 0;
		}
	}
	else {
		MaxFoldWd = (ViewBox->ClientWidth - HchWidth*2 - TopXpos) / HchWidth;
	}

	if (ColorPanel) {
		ColorPanel->ClientHeight = FontHeight;
		ColorPanel->ClientWidth  = FontHeight * 2;
	}

	if (set_hi) {
		SetScrBar();
		UpdatePos(true, true);
	}
}

//---------------------------------------------------------------------------
//XN[o[XV
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetScrBar()
{
	if (ScrBar && MaxDispLine>0) {
		ScrBar->Visible = (ScrBarStyle==0);

		ScrBar->Max = MaxDispLine + 1;
		ScrBar->LargeChange = LineCount;

		SCROLLINFO si;
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask = SIF_PAGE;
		si.nPage = LineCount + 1;
		::SetScrollInfo(ScrBar->Handle, SB_CTL, &si, TRUE);

		ScrPanel->UpdateKnob();
		ScrPanel->Repaint();
	}
}

//---------------------------------------------------------------------------
//zTSV`ɕϊ
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::ArrayToTsv(TStringDynArray lst)
{
	UnicodeString ret_str;
	for (int i=0; i<lst.Length; i++) {
		if (i>0) ret_str.UCAT_T("\t");
		ret_str += lst[i];
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//CSV/TSV Œ蒷\ɐ`
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::FormatFixed(TStringList *txt_lst)
{
	if (txt_lst->Count==0) return;

	//Ps
	bool is_tsv = contains_s(txt_lst->Strings[0], _T('\t'));
	TStringDynArray hdr_buf = is_tsv? split_strings_tab(txt_lst->Strings[0]) : get_csv_array(txt_lst->Strings[0], MAX_CSV_ITEM);
	if (hdr_buf.Length==0) return;
	int c_cnt = hdr_buf.Length;
	IsNumList.Length = c_cnt;
	FixWdList.Length = c_cnt;
	for (int j=0; j<c_cnt; j++) {
		FixWdList[j] = str_len_half(hdr_buf[j]);
		IsNumList[j] = true;
	}
	if (!is_tsv) txt_lst->Strings[0] = ArrayToTsv(hdr_buf);

	//Qsڈȍ~
	for (int i=1; i<txt_lst->Count; i++) {
		TStringDynArray itm_buf = is_tsv? split_strings_tab(txt_lst->Strings[i]) : get_csv_array(txt_lst->Strings[i], c_cnt, true);
		itm_buf.Length = c_cnt;
		for (int j=0; j<c_cnt; j++) {
			//ő啝
			int hlen = str_len_half(itm_buf[j]);
			if (hlen>FixWdList[j]) FixWdList[j] = hlen;
			//l`FbN
			if (IsNumList[j]) {
				UnicodeString s = Trim(itm_buf[j]);
				for (int k=1; k<=s.Length(); k++) {
					if (!iswdigit(s[k]) && s[k]!='.' && s[k]!=',' && s[k]!='-' && s[k]!='+') {
						IsNumList[j] = false; break;
					}
				}
			}
		}
		if (!is_tsv) txt_lst->Strings[i] = ArrayToTsv(itm_buf);
	}

	//
	if (ViewFixedLimit>0 && ViewFixedLimit<4) ViewFixedLimit = 4;	//***
	if (ViewFixedLimit>0) {
		int fld_wd = !isFitWin? ViewFoldWidth : MaxFoldWd;
		for (int j=c_cnt-1; j>=0; j--) {
			//v
			int rec_w = 0;
			for (int k=0; k<c_cnt; k++) {
				if (k>0) rec_w += 2;
				rec_w += FixWdList[k];
			}
			if (rec_w<=fld_wd) break;
			//
			FixWdList[j] = std::min(FixWdList[j], ViewFixedLimit);
		}
	}

	//`
	for (int i=0; i<txt_lst->Count; i++) {
		UnicodeString lbuf = txt_lst->Strings[i];
		UnicodeString nbuf;
		for (int j=0; j<c_cnt; j++) {
			if (j>0) nbuf.UCAT_T("  ");
			UnicodeString s = split_pre_tab(lbuf);
			int dlen = FixWdList[j] - str_len_half(s);
			//ȗ
			if (dlen<0) {
				int s_w = FixWdList[j] - 2;
				for (int k=1; k<=s.Length(); k++) {
					if (str_len_half(s.SubString(1, k)) > s_w) {
						s = s.SubString(1, k - 1).UCAT_T("c");
						break;
					}
				}
				dlen = FixWdList[j] - str_len_half(s);
			}
			//󔒕t
			if (dlen>0) {
				if (IsNumList[j])
					s = StringOfChar(_T(' '), dlen) + s;
				else
					s += StringOfChar(_T(' '), dlen);
			}
			nbuf += s;
		}
		txt_lst->Strings[i] = nbuf;
	}
}

//---------------------------------------------------------------------------
//ʂɍ킹čseݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::UpdateScr(
	int lno)	//sԍ 0 = ݍs		(default = 1)
{
	isReady = false;
	cursor_HourGlass();

	if (UserHighlight->Recycle()) AddErr_Highlight();

	if (lno==0) lno = get_CurLineNo();

	if (RulerBox) {
		RulerBox->Visible = ShowTextRuler;
		if (RulerBox->Visible) RulerBox->Repaint();
	}

	UnicodeString fext = get_extension(FileName);

	bool is_xml = false;
	if (!isBinary && TxtBufList->Count>0)
		is_xml = (StartsText("<?xml ", TxtBufList->Strings[0]) || test_FileExt(fext, FEXT_XML));

	//󕶌ɂH
	isAozora = ChkAozora && test_FileExt(fext, _T(".txt")) && is_match_regex(TxtBufList->Text, _T("m.*?n"));

	isIniFmt = isAwstats = isNyanTxt = false;
	if (!isBinary && !isLog && !is_xml && !isAozora) {
		//ZNVĂ邩H
		isIniFmt = test_FileExt(fext, _T(".ini.inf.reg.url"));
		if (!isIniFmt && !test_FileExt(fext, _T(".txt.log") FEXT_PROGRAM FEXT_HTML)) {
			TRegExOptions opt; opt << roMultiLine;
			isIniFmt = TRegEx::IsMatch(TxtBufList->Text, "^\\[[a-zA-Z0-9_ ]+\\]$", opt);
		}
		//AWStatsf[H
		if (test_FileExt(fext, _T(".txt")) && StartsStr("awstats", ExtractFileName(FileName))) {
			isAwstats = StartsStr("AWSTATS DATA FILE", TxtBufList->Text);
		}
		//NyanFipeLXgH
		if (!isIniFmt) {
			UnicodeString lbuf = get_top_line(FileName);
			isNyanTxt = USAME_TI(lbuf, ";[MenuFile]") || USAME_TI(lbuf, ";[ResultList]");
		}
	}

	//op^[ݒ
	HeadlinePtn = EmptyStr;
	if (EmpHeadline && !isBinary) {
		if (test_FileExt(fext, _T(".bat.cmd.qbt")))
			HeadlinePtn.USET_T("^:[^:]+");
		else if (test_FileExt(fext, _T(".eml")))
			HeadlinePtn.USET_T("^Subject:");
		else if (test_FileExt(fext, _T(".hsp")))
			HeadlinePtn.USET_T("^\\*\\w+");
		else if (test_FileExt(fext, _T(".md")))
			HeadlinePtn.USET_T("^#+");
		else if (isAozora)
			HeadlinePtn.USET_T("m.*?(|)on|^@*?([O-X]+|[OlܘZ\QESZ]+)$");
		else if (isAwstats)
			HeadlinePtn.USET_T("^BEGIN_.+?");
		else if (isLog)
			HeadlinePtn.USET_T("^.>\\d{2}:\\d{2}:\\d{2}\\s(NyanFi|.+(Jn|ڑ))");
		else if (test_HtmlExt(fext)) {
			if (isHtm2Txt) {
				if (ToMarkdown) {
					HeadlinePtn.USET_T("^#+\\s");
				}
				else if (!HtmHdrStr.IsEmpty()) {
					HeadlinePtn.USET_T("^(");
					UnicodeString hbuf = HtmHdrStr;
					for (int i=0; i<6; i++) {
						UnicodeString hc = split_tkn(hbuf, ';');
						if (!hc.IsEmpty()) {
							if (i>0) HeadlinePtn.UCAT_T("|");
							HeadlinePtn += hc;
						}
					}
					HeadlinePtn.UCAT_T(").+");
				}
			}
			else
				HeadlinePtn.USET_T("<[hH][1-6]");
		}
		else if (isIniFmt)
			HeadlinePtn.USET_T("^\\[.+?\\]");
		else
			HeadlinePtn = HeadlineList->Values[get_tkn_r(fext, '.').LowerCase()];

		if (!chk_RegExPtn(HeadlinePtn)) HeadlinePtn = EmptyStr;
	}

	//--------------------------
	//\擾
	//--------------------------
	RemLnList->Clear();  RemBgnList->Clear();  RemEndList->Clear();
	ReservedPtn   = EmptyStr;
	ReservedCase  = true;
	NumericPtn	  = EmptyStr;
	SymbolChs	  = EmptyStr;
	QuotStr 	  = EmptyStr;
	useEsc		  = true;
	CharPtn 	  = EmptyStr;
	RubyPtn 	  = EmptyStr;
	UsrKeyword	  = EmptyStr;
	UsrKeywdCase  = true;
	UsrKeyword2   = EmptyStr;
	UsrKeywdCase2 = true;
	UsrKeywdCol   = color_fgView;
	UsrKeywdCol2  = color_fgView;
	alt_BackSlash = AltBackSlash;

	//[U`̎擾
	bool usr_hl = UserHighlight->GetSection(FileName, isClip, isLog, isHtm2Txt);

	//tHg
	useFontName = usr_hl? UserHighlight->ReadKeyStr(_T("FontName")) : ViewerFont->Name;
	if (useFontName.IsEmpty()) useFontName = ViewerFont->Name;
	useFontSize = usr_hl? UserHighlight->ReadKeyInt(_T("FontSize")) : ViewerFont->Size;
	if (useFontSize==0) useFontSize = ViewerFont->Size;
	ViewBox->Font->Assign(ViewerFont);
	ViewBox->Font->Name = useFontName;
	ViewBox->Font->Size = useFontSize;

	if (!isBinary) {
		if (usr_hl) {
			UnicodeString key;
			//sRg
			for (int i=1; ; i++) {
				UnicodeString vstr = UserHighlight->ReadKeyStr(key.sprintf(_T("Comment%u"), i).c_str());
				if (vstr.IsEmpty()) break;
				RemLnList->Add(vstr);
			}
			//ubNRg
			for (int i=1; ; i++) {
				UnicodeString b_str = UserHighlight->ReadKeyStr(key.sprintf(_T("CommentBgn%u"), i).c_str());
				UnicodeString e_str = UserHighlight->ReadKeyStr(key.sprintf(_T("CommentEnd%u"), i).c_str());
				if (b_str.IsEmpty() || e_str.IsEmpty()) break;
				RemBgnList->Add(b_str);
				RemEndList->Add(e_str);
			}

			ReservedPtn   = UserHighlight->ReadRegExPtn(_T("ReservedPtn"));
			ReservedCase  = UserHighlight->ReadKeyBool( _T("ReservedCase"),	true);
			NumericPtn	  = UserHighlight->ReadRegExPtn(_T("NumericPtn"));
			SymbolChs	  = UserHighlight->ReadKeyStr(  _T("Symbol"));
			QuotStr 	  = UserHighlight->ReadKeyStr(  _T("Strings"));
			useEsc		  = UserHighlight->ReadKeyBool( _T("UseEsc"),		true);
			UsrKeyword	  = UserHighlight->ReadRegExPtn(_T("KeywordPtn"));
			UsrKeywdCase  = UserHighlight->ReadKeyBool( _T("KeywordCase"),	true);
			UsrKeyword2   = UserHighlight->ReadRegExPtn(_T("KeywordPtn2"));
			UsrKeywdCase2 = UserHighlight->ReadKeyBool( _T("KeywordCase2"),	true);

			//os
			UnicodeString lbuf = UserHighlight->ReadRegExPtn(_T("HeadlinePtn"));
			if (!lbuf.IsEmpty()) HeadlinePtn = lbuf;

			//zF
			UnicodeString col_fnam = UserHighlight->ReadKeyStr(_T("ColorIniFile"));
			if (!col_fnam.IsEmpty()) SetColor(col_fnam);
			color_Comment  = UserHighlight->ReadColorRGB6H(_T("CommentCol"),	color_Comment);
			color_Reserved = UserHighlight->ReadColorRGB6H(_T("ReservedCol"),	color_Reserved);
			color_Numeric  = UserHighlight->ReadColorRGB6H(_T("NumericCol"),	color_Numeric);
			color_Symbol   = UserHighlight->ReadColorRGB6H(_T("SymbolCol"),		color_Symbol);
			color_Strings  = UserHighlight->ReadColorRGB6H(_T("StringsCol"),	color_Strings);
			color_Headline = UserHighlight->ReadColorRGB6H(_T("HeadlineCol"),	color_Headline);
			UsrKeywdCol    = UserHighlight->ReadColorRGB6H(_T("KeywordCol"),	color_fgView);
			UsrKeywdCol2   = UserHighlight->ReadColorRGB6H(_T("KeywordCol2"),	color_fgView);

			//̑
			if (UserHighlight->KeyExists(UserHighlight->CurSection, _T("AltBackSlash")))
				alt_BackSlash = UserHighlight->ReadKeyBool(_T("AltBackSlash"));
		}
		//ftHg
		else {
			//Rg
			if (EmpComment) {
				if (isAwstats)
					RemLnList->Add("#");
				else if (test_FileExt(fext, _T(".bat.cmd")))
					RemLnList->Add("$BAT");
				else if (test_FileExt(fext, _T(".nbt.qbt")))
					RemLnList->Add("$QBT");
				else if (isIniFmt || isNyanTxt)
					RemLnList->Add("$INI");
				else
					UserHighlight->GetCommentList(FileName, RemLnList, RemBgnList, RemEndList, isHtm2Txt, true);
			}

			//\
			if (EmpReserved) ReservedPtn = GetDefReservedPtn(fext, ReservedCase, is_xml, isLog, isHtm2Txt);
			//l
			if (EmpNumeric)  NumericPtn  = GetDefNumericPtn(fext);
			//V{
			if (EmpSymbol)   SymbolChs   = GetDefSymbolChars(fext, is_xml, isHtm2Txt);

			//p
			if (EmpStrings) {
				QuotStr = GetDefQuotChars(fext, useEsc, is_xml, isIniFmt, isHtm2Txt);
				if (test_FileExt(fext, FEXT_C_SH _T(".idl.cs.hs.js.jsx.java.vhd"))) CharPtn.USET_T("'\\\\?.'");
			}

			SetColor();
		}

		//r
		if (EmpRuby) {
			if (isAozora)
				RubyPtn.USET_T("s.*?t|b");
			else if (test_HtmlExt(fext) && isHtm2Txt)
				RubyPtn.USET_T("(\\(|i)[-@-]+(\\)|j)");
		}
	}

	//--------------------------
	//\p^[ݒ
	//--------------------------
	//0									\
	EmPtn[0] = ReservedPtn;	
	EmBgC[0] = clNone;
	EmFgC[0] = color_Reserved;
	//1									URL
	EmPtn[1].USET_T("(" URL_MATCH_PTN ")|(" MAIL_MATCH_PTN ")");
	EmBgC[1] = clNone;
	EmFgC[1] = color_URL;
	//2									
	EmPtn[2] = EmptyStr;
	EmBgC[2] = color_bgEmp;
	EmFgC[2] = color_fgEmp;

	//3
	if (isLog && UserHighlight->CurSection.IsEmpty()) {	//fBNg
		EmPtn[3].USET_T("(([a-zA-Z]:|\\\\)\\\\([^/*?\"<>|]+\\\\)*)|(\\[.*?\\])");
		EmFgC[3] = color_Folder;
	}
	else if (!CharPtn.IsEmpty()) {		//
		EmPtn[3] = CharPtn;
		EmFgC[3] = color_Strings;
	}
	else if (isBinary) {				//oCi3
		EmPtn[3] = EmpBinPtn3;
		EmFgC[3] = color_fgEmpBin3;
	}
	else {								//[Jt@C
		EmPtn[3] = LOCAL_FILE_PTN;
		EmFgC[3] = color_LocalLink;
	}
	EmBgC[3] = clNone;

	//4
	if (isBinary) {						//oCi2
		EmPtn[4] = EmpBinPtn2;
		EmFgC[4] = color_fgEmpBin2;
	}
	else if (!NumericPtn.IsEmpty())	{	//l
		EmPtn[4] = NumericPtn;
		EmFgC[4] = color_Numeric;
	}
	else if (isLog) {					//ÕfobO
		EmPtn[4].USET_T("^.>       !( .+)?");
		EmFgC[4] = AdjustColor(color_fgView, 96);
	}
	else {								//r
		EmPtn[4] = RubyPtn;
		EmFgC[4] = color_Ruby;
	}
	EmBgC[4] = clNone;

	//5
	if (isBinary) {						//oCi1
		EmPtn[5] = EmpBinPtn1;
		EmFgC[5] = color_fgEmpBin1;
	}
	else if (isLog && UserHighlight->CurSection.IsEmpty()) {	//ÕG[
		EmPtn[5].USET_T("(^.>([ECW]|(     [45]\\d{2})) .*)|(\\b(ERR|NG):\\d+)");
		EmFgC[5] = color_Error;
	}
	else if (isAozora) {				//󕶌
		EmPtn[5].USET_T("|m.*?n");
		EmFgC[5] = color_Comment;
	}
	else {								//[U`L[[h
		EmPtn[5] = UsrKeyword;
		EmFgC[5] = UsrKeywdCol;
	}
	EmBgC[5] = clNone;

	//6									[U`L[[h2
	EmPtn[6] = UsrKeyword2;
	EmFgC[6] = UsrKeywdCol2;
	EmBgC[6] = clNone;
	//--------------------------

	SetMetric();
	SelStart = SelEnd = CurPos = Point(0, 0);
	LastPos  = Point(-1, -1);
	LastTop  = -1;
	LastSel  = false;

	//\obt@ݒ
	//oCi_v
	if (isBinary) {
		MaxHchX = MAX_BIN_HCH_X;
	}
	//eLXg
	else {
		ClearDispLine();

		int max_wd;
		if (!isFitWin && ViewFoldWidth>0) {
			max_wd	= (ViewFoldWidth - 1) * HchWidth;
			MaxHchX = ViewFoldWidth;
		}
		else {
			max_wd	 = ViewBox->ClientWidth - HchWidth*2 - TopXpos;
			MaxHchX  = MaxFoldWd + 1;
			isFitWin = true;
		}

		isLimited = isContinue = false;

		std::unique_ptr<TStringList> txt_buf(new TStringList());
		txt_buf->Assign(TxtBufList);

		//HTMLeLXgϊ
		if (test_HtmlExt(fext) && isHtm2Txt) {
			std::unique_ptr<HtmConv> htmcnv(new HtmConv());
			ini_HtmConv_def(htmcnv.get(), FileName);
			htmcnv->LineWidth = MaxHchX;
			htmcnv->InsHdrInf = true;
			htmcnv->HtmBuf->Assign(txt_buf.get());
			htmcnv->Convert();
			for (int i=0; i<htmcnv->TxtBuf->Count; i++) htmcnv->TxtBuf->Objects[i] = (TObject*)(NativeInt)i;
			TxtBufList2->Assign(htmcnv->TxtBuf);
			txt_buf->Assign(htmcnv->TxtBuf);
		}
		//CSV/TSV(Œ蒷\)
		else if (test_FileExt(fext, FEXT_CSV)) {
			isCSV = true;
			isTSV = (txt_buf->Count>0 && contains_s(txt_buf->Strings[0], _T('\t')));
			if (isFixedLen) FormatFixed(txt_buf.get());
		}
		//󕶌Ɍ`
		else if (isAozora) {
			int ind_n   = 0;
			for (int i=0; i<txt_buf->Count; i++) {
				UnicodeString lbuf = txt_buf->Strings[i];
				if (StartsStr("m", lbuf)) {
					//Ps
					if (is_match_regex(lbuf, _T("m[P-X]+n"))) {
						lbuf  = replace_regex(lbuf, _T("m([P-X]+)n"), _T("\\1\t"));
						ind_n = to_HalfWidth(get_pre_tab(lbuf)).ToIntDef(0);
						if (ind_n>0)
							txt_buf->Strings[i] = StringOfChar(_T('@'), ind_n) + get_post_tab(lbuf);
					}
					//グ
					else if (is_match_regex(lbuf, _T("mn[P-X]+グn"))) {
						lbuf  = replace_regex(lbuf, _T("mn([P-X]+)グn"), _T("\\1\t"));
						ind_n = to_HalfWidth(get_pre_tab(lbuf)).ToIntDef(0);
						if (ind_n>0) {
							lbuf  = get_post_tab(lbuf);
							ind_n = MaxHchX/2 - lbuf.Length()-ind_n;
							if (ind_n>0) txt_buf->Strings[i] = StringOfChar(_T('@'), ind_n) + lbuf;
						}
					}
					//nt
					else if (USAME_TS(lbuf, "mntn")) {
						lbuf.Delete(1, 6);
						ind_n = MaxHchX/2 - lbuf.Length();
						if (ind_n>0) txt_buf->Strings[i] = StringOfChar(_T('@'), ind_n) + lbuf;
					}
					//Ay[W
					else if (USAME_TS(lbuf, "mn") || USAME_TS(lbuf, "my[Wn"))
						txt_buf->Strings[i] = StringOfChar(_T(''), MaxHchX/2);
				}
				//r
				else {
					if (i<30 && is_match_regex(lbuf, _T("^-{10,}$")))
						txt_buf->Strings[i] = StringOfChar(_T(''), MaxHchX/2);
				}
			}
		}

		//r\
		if (!ShowRuby && !RubyPtn.IsEmpty()) {
			for (int i=0; i<txt_buf->Count; i++)
				txt_buf->Strings[i] = TRegEx::Replace(txt_buf->Strings[i], RubyPtn, EmptyStr);
			RubyPtn = EmptyStr;
		}

		MaxLine = txt_buf->Count;
		if (lno>MaxLine) lno = MaxLine;

		bool isNrm	= true;
		int  ind_n	= -1;	//
		int  ind_n2 = -1;	//܂Ԃ̎
		int  alr_n	= -1;	//n̎グ

		bool q_in_rem = false;
		if (!QuotStr.IsEmpty()) {
			for (int i=0; i<RemBgnList->Count && !q_in_rem; i++) {
				for (int j=1; j<=RemBgnList->Strings[i].Length() && !q_in_rem; j++) {
					if (ContainsStr(QuotStr, RemBgnList->Strings[i][j])) q_in_rem = true;
				}
			}
			for (int i=0; i<RemEndList->Count && !q_in_rem; i++) {
				for (int j=1; j<=RemEndList->Strings[i].Length() && !q_in_rem; j++) {
					if (ContainsStr(QuotStr, RemEndList->Strings[i][j])) q_in_rem = true;
				}
			}
		}

		for (int i=0; i<MaxLine; i++) {
			UnicodeString lbuf = txt_buf->Strings[i];
			int org_lno  = (int)txt_buf->Objects[i] + 1;
			int lbuf_len = lbuf.Length();

			//̉
			std::unique_ptr<WideChar []> qch_buf(new WideChar[lbuf_len + 1]);
			WideChar *qch_ln = qch_buf.get();
			WideChar qch = '\0';
			if (!QuotStr.IsEmpty()) {
				bool isEsc = false;
				for (int j=1; j<=lbuf_len; j++) {
					WideChar cj = lbuf[j];
					if		(isEsc)				 isEsc = false;
					else if (useEsc && cj=='\\') isEsc = true;
					else if (ContainsText(QuotStr, cj))	qch = (qch==cj)? '\0' : cj;
					qch_ln[j] = qch;
				}
			}
			else
				for (int j=1; j<=lbuf_len; j++) qch_ln[j] = '\0';

			//Rg̉
			int RemPos0 = 0, RemPos1 = 0;
			if (RemLnList->Count>0 || RemBgnList->Count>0) {
				UnicodeString tbuf = TrimLeft(lbuf);
				bool ok = false;
				if (RemLnList->Count>0) {
					ok = true;
					if (USAME_TS(RemLnList->Strings[0], "$BAT")) {
						if (StartsText("REM", tbuf) || StartsText("@REM",tbuf) || StartsStr("::", tbuf)) {
							RemPos0 = 1;  RemPos1 = lbuf_len;
						}
					}
					else if (USAME_TS(RemLnList->Strings[0], "$QBT")) {
						if (StartsText("REM", tbuf) || StartsStr(';', tbuf)) {
							RemPos0 = 1;  RemPos1 = lbuf_len;
						}
					}
					else if (USAME_TS(RemLnList->Strings[0], "$INI")) {
						if (StartsStr(';', lbuf)) {
							RemPos0 = 1;  RemPos1 = lbuf_len;
						}
					}
					else ok = false;
				}

				if (!ok) {
					int j = 1;
					while (j<=lbuf_len) {
						bool matched = false;
						WideChar qch = qch_ln[j];
						//ł͂Ȃ
						if (qch=='\0') {
							//PsRg
							if (isNrm) {
								for (int i_r=0; i_r<RemLnList->Count; i_r++) {
									int rn = RemLnList->Strings[i_r].Length();
									for (int k=1; k<=rn; k++) {
										int cp = j + k - 1;  if (cp>lbuf_len) break;
										if (RemLnList->Strings[i_r][k]!=lbuf[cp]) break;
										matched = (k==rn);
									}
								}
								if (matched) {
									bool ln_ok = true;
									for (int i_r=0; ln_ok && i_r<RemBgnList->Count; i_r++) {
										int rn = RemBgnList->Strings[i_r].Length();
										for (int k=1; k<=rn; k++) {
											int cp = j + k - 1;  if (cp>lbuf_len) break;
											if (RemBgnList->Strings[i_r][k]!=lbuf[cp]) break;
											if (k==rn) ln_ok = false;
										}
									}
									for (int i_r=0; ln_ok && i_r<RemEndList->Count; i_r++) {
										int rn = RemEndList->Strings[i_r].Length();
										for (int k=1; k<=rn; k++) {
											int cp = j + k - 1;  if (cp>lbuf_len) break;
											if (RemEndList->Strings[i_r][k]!=lbuf[cp]) break;
											if (k==rn) ln_ok = false;
										}
									}
									if (ln_ok) {
										RemPos0 = j;
										break;
									}
									else matched = false;
								}
							}
						}

						//sRg
						if (qch=='\0' || q_in_rem) {
							for (int i_r=0; !matched && i_r<RemBgnList->Count; i_r++) {
								if (isNrm) {
									int rn = RemBgnList->Strings[i_r].Length();
									for (int k=1; k<=rn; k++) {
										int cp = j + k - 1;  if (cp>lbuf_len) break;
										if (RemBgnList->Strings[i_r][k]!=lbuf[cp]) break;
										matched = (k==rn);
									}
									if (matched) {
										RemPos0 = j;  j += (rn - 1);
										isNrm = false;
									}
								}
								else {
									int rn = RemEndList->Strings[i_r].Length();
									for (int k=1; k<=rn; k++) {
										int cp = j + k - 1;  if (cp>lbuf_len) break;
										if (RemEndList->Strings[i_r][k]!=lbuf[cp]) break;
										matched = (k==rn);
									}
									if (matched) {
										RemPos1 = j + rn -1;  j += rn;
										isNrm	= true;
									}
								}
							}
						}
						j++;
					}

					if		(RemPos0>0 && RemPos1==0)  RemPos1 = lbuf_len;
					else if (RemPos1>0 && RemPos0==0)  RemPos0 = 1;
					else if (!isNrm && RemPos0==0 && RemPos1==0) {
						RemPos0 = 1;  RemPos1 = lbuf_len;
					}
				}
			}

			//󕶌ɂ̃ubN
			if (isAozora) {
				if (StartsStr("m", lbuf)) {
					//
					if (is_match_regex(lbuf, _T("m[P-X]+n"))) {
						UnicodeString nbuf = to_HalfWidth(
							replace_regex(lbuf, _T("m([P-X]+)n"), _T("\\1")));
						ind_n = nbuf.ToIntDef(0);
						lbuf  = EmptyStr;
					}
					else if (is_match_regex(lbuf, _T("m[P-X]+A܂Ԃ[P-X]+n"))) {
						UnicodeString nbuf = to_HalfWidth(
							replace_regex(lbuf, _T("m([P-X]+)A܂Ԃ([P-X]+)n"), _T("\\1,\\2")));
						ind_n  = split_tkn(nbuf, ',').ToIntDef(0);
						ind_n2 = nbuf.ToIntDef(0);
						lbuf   = EmptyStr;
					}
					else if (USAME_TS(lbuf, "mŎIn")) {
						ind_n = ind_n2 = -1;
						lbuf  = EmptyStr;
					}
					//nt
					else if (USAME_TS(lbuf, "mntn")) {
						alr_n = 0;
						lbuf  = EmptyStr;
					}
					else if (USAME_TS(lbuf, "mŒntIn")) {
						alr_n = -1;
						lbuf  = EmptyStr;
					}
					//グ
					else if (is_match_regex(lbuf, _T("mn[P-X]+グn"))) {
						UnicodeString nbuf = to_HalfWidth(
							replace_regex(lbuf, _T("mn([P-X]+)グn"), _T("\\1")));
						alr_n = nbuf.ToIntDef(0);
						lbuf  = EmptyStr;
					}
					else if (USAME_TS(lbuf, "mŎグIn")) {
						alr_n = -1;
						lbuf  = EmptyStr;
					}
				}

				if (ind_n>0) lbuf.Insert(StringOfChar(_T('@'), ind_n), 1);
				if (alr_n>=0) {
					int n = MaxHchX/2 - lbuf_len - alr_n;
					if (n>0) lbuf = StringOfChar(_T('@'), n) + lbuf;
				}
			}

			//--------------------------
			//\obt@ݒ
			//--------------------------
			if (lbuf.IsEmpty())
				AddDispLine("\n", org_lno);
			else if ((i==MaxLine-1) && USAME_TS(lbuf, TXLIMIT_MARK)) {
				isLimited = isContinue = true;
				AddDispLine(EmptyStr, org_lno);
			}
			else {
				int idx = 0, ofs = 0;
				UnicodeString tmp_buf = lbuf;
				while (!tmp_buf.IsEmpty()) {
					int n = 1;
					int w = 0;
					for (int j=1; j<tmp_buf.Length(); j++,n++) {
						w = add_CharWidth(tmp_buf[j], w);	if (w>max_wd) break;
					}

					UnicodeString sbuf = tmp_buf.SubString(1, n);	tmp_buf.Delete(1, n);
					if (ind_n2>0 && !tmp_buf.IsEmpty()) tmp_buf.Insert(StringOfChar(_T('@'), ind_n2), 1);
					if (tmp_buf.IsEmpty()) sbuf.UCAT_T("\n");
					line_rec *lp = AddDispLine(sbuf, org_lno, idx++);

					//擪񂩂ݒ
					if (ofs<lbuf_len) lp->topQch = qch_ln[1 + ofs];
					//Rg͈͐ݒ
					if (RemPos0>0) {
						lp->RemPos0 = (RemPos0 <= n+ofs)? std::max(RemPos0-ofs, 1) : 0;
						lp->RemPos1 = (RemPos1 <= n+ofs)? std::max(RemPos1-ofs, 0) : (lp->RemPos0>0)? n : 0;
					}
					ofs += n;
				}
			}
		}	//end of for

		AddDispLine(EmptyStr, -1);
		MaxDispLine = DispLines->Count;
		BinarySize = 0;
	}

	SetScrBar();

	ToLine(lno);
	ScrPanel->UpdateKnob();

	isReady = true;
	Repaint(true);

	IniSelected();
	SetSttInf();

	cursor_Default();
}

//---------------------------------------------------------------------------
//eLXgeݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::AssignText(
	TStrings *lst,
	int lno,			//sԍ (default = 1)  0:Q
	int sort_mode)		//\[g[h 0:/ 1:/ -1:~
{
	isText = isBinary = isXDoc2Txt = false;
	isCSV  = isTSV    = false;
	if (!ViewBox) return;

	isText = true;
	isLog  = !isClip && (FileName.IsEmpty() || str_match(UAPP_T(ExePath, "tasklog*.txt"), FileName));
	isXDoc2Txt = UseXd2tx && xd2tx_TestExt(get_extension(FileName));

	if (lst) {
		SortMode = 0;
		TxtBufList->Assign(lst);
		for (int i=0; i<TxtBufList->Count; i++) TxtBufList->Objects[i] = (TObject*)(NativeInt)i;
	}
	else {
		//\[g
		cursor_HourGlass();
		SortMode = sort_mode;
		if (SortMode==0)
			TxtBufList->CustomSort(comp_ObjectsOrder);
		else {
			//w
			if (CsvCol>=0) {
				USR_CsvCol		= CsvCol;
				USR_CsvSortMode = SortMode;
				USR_CsvTopIsHdr = TopIsHeader;
				TxtBufList->CustomSort(isTSV? comp_TsvNaturalOrder : comp_CsvNaturalOrder);
			}
			//ʏ
			else TxtBufList->CustomSort((SortMode==1)? comp_AscendOrder : comp_DescendOrder);
		}
		cursor_Default();
	}

	//sʒu𕜌
	if (lno==0) {
		TStringDynArray itm_buf = record_of_csv_list(TextViewHistory, FileName, 0, 3);
		if (itm_buf.Length==3) {
			if (RestoreViewLine) lno = itm_buf[1].ToIntDef(0);
			MarkListStr = itm_buf[2];
		}
		if (lno==0) lno = 1;
	}

	UpdateScr(lno);
	FuncListDlg->ClearList();
}

//---------------------------------------------------------------------------
//oCit@Cǂݍœeݒ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::AssignBin(
	__int64 top_adr,		//擪AhX	(default = 0)
	bool reload,			//ēǂݍ	(default = false: }[N𕜌)
	unsigned int adr)		//ړAhX	(default = 0)
{
	isText = isBinary = isXDoc2Txt = false;
	if (!ViewBox) return false;

	try {
		cursor_HourGlass();
		isBinary = true;

		TxtBufList->Clear();
		ClearDispLine();

		//t@Cǂݍ
		TopAddress	= top_adr;
		MMF->MapEnabled = BinMemMaped;
		if (!MMF->OpenRO(FileName, TopAddress, ViewBinLimitSize)) Abort();
		BinFileSize = MMF->FileSize;
		BinarySize	= MMF->BuffSize;
		isLimited	= BinarySize < BinFileSize;
		isContinue	= (TopAddress + BinarySize) < BinFileSize;
		MaxDispLine = BinarySize/16 + 1;
		if (BinarySize%16) MaxDispLine++;
		MaxLine = MaxDispLine -1;

		//}[N𕜌
		if (!reload) {
			TStringDynArray itm_buf = record_of_csv_list(TextViewHistory, FileName, 0, 3);
			if (itm_buf.Length==3) MarkListStr = itm_buf[2];
		}

		UpdateScr();
		FuncListDlg->ClearList();

		//rbg}bvr[̍XV
		if (BitmapForm->Visible) {
			BitmapForm->BitmapBox->ClientHeight = BinarySize/BitmapForm->MapWidth + 1;
			BitmapForm->BitmapBox->Invalidate();
		}
		cursor_Default();
		return ToAddrR(adr);
	}
	catch (EAbort &e) {
		GlobalErrMsg   = e.Message;
		cursor_Default();
		return false;
	}
	catch (...) {
		cursor_Default();
		return false;
	}
}

//---------------------------------------------------------------------------
//sH
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::has_CR(UnicodeString s)
{
	return ends_tchs(_T("\n\r"), s);
}

//---------------------------------------------------------------------------
//^ul1̕\ǉ
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::add_CharWidth(WideChar c, int w)
{
	if (c=='\t') {
		w += HchWidth;
		int dt = w % TabWidth;
		if (dt>0) w += (TabWidth - dt);
	}
	else
		w += get_TextWidth(ViewCanvas, c, IsIrregFont);
	return w;
}
//---------------------------------------------------------------------------
//^ulĕ̕\擾
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::get_StrWidth(UnicodeString s)
{
	int w = 0;
	int i = 1;
	while (i<=s.Length()) {
		WideChar c = s[i];
		if (c=='\t') {
			w += HchWidth;
			int dt = w % TabWidth;
			if (dt>0) w += (TabWidth - dt);
			i++;
		}
		else {
			if (s.IsLeadSurrogate(i)) {
				w += get_TextWidth(ViewCanvas, s.SubString(i, 2), IsIrregFont);
				i += 2;
			}
			else {
				w += get_TextWidth(ViewCanvas, c, IsIrregFont);
				i++;
			}
		}
	}
	return w;
}

//---------------------------------------------------------------------------
//J[\s̖ʒu擾
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::get_CurEndPos()
{
	UnicodeString lbuf = get_CurLine();
	int p = lbuf.Length(); if (p>0 && has_CR(lbuf)) p--;
	if (isBinary && LimitBinCsr) p = std::min(p, 46);
	return p;
}

//---------------------------------------------------------------------------
//ʒu甼pZʒuւ̕ϊ(^ul)
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::cv_PosX_to_HchX(int px)
{
	UnicodeString lbuf = get_CurLine();
	if (isBoxMode) lbuf += StringOfChar(_T(' '), MaxHchX);
	lbuf = lbuf.SubString(1, px);

	int w = 0;
	while (!lbuf.IsEmpty()) {
		int p_t = lbuf.Pos('\t');
		if (p_t>0) {
			if (p_t>1) w += get_TextWidth(ViewCanvas, lbuf.SubString(1, p_t - 1), IsIrregFont);
			w = add_CharWidth('\t', w);
			lbuf.Delete(1, p_t);
		}
		else {
			w += get_TextWidth(ViewCanvas, lbuf, IsIrregFont);
			lbuf = EmptyStr;
		}
	}

	int x = w/HchWidth;
	if (isBoxMode) x = std::min(x, MaxHchX);
	return x;
}

//---------------------------------------------------------------------------
//CSVʒuݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::set_CurCsvCol()
{
	CsvCol = -1;
	if (isCSV && isFixedLen && FixWdList.Length>0) {
		line_rec *lp = get_LineRec(CurPos.y);
		int cp = lp->LineIdx*MaxHchX + cv_PosX_to_HchX(CurPos.x);
		CsvCol = 0;
		for (int i=0,wd=0; i<FixWdList.Length-1; i++,CsvCol++) {
			wd += (FixWdList[i] + 2); if (wd>cp) break;
		}
	}
}
//---------------------------------------------------------------------------
//CSVʒu猅ݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::set_PosFromCol(int col)
{
	if (isFixedLen && FixWdList.Length>0) {
		IniSelected();

		int xw = 0;
		for (int i=0; i<FixWdList.Length && i<col; i++) xw += (FixWdList[i] + 2);
		CurHchX = xw;

		UnicodeString lbuf = get_CurLine();
		for (int i=1; i<=lbuf.Length(); i++) {
			if (CurHchX<str_len_half(lbuf.SubString(1, i))) {
				CurPos.x = i - 1;
				if (lbuf.IsTrailSurrogate(i)) CurPos.x--;
				break;
			}
		}

		CsvCol = col;
		Repaint();
		SetSttInf();
	}
}

//---------------------------------------------------------------------------
//I𖖔ݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::set_SelEnd()
{
	SelEnd = BoxEnd = CurPos;
	BoxEnd.x = CurHchX;
}

//---------------------------------------------------------------------------
//ʒuݍs̕傫ꍇ̈ʒu
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::adjust_PosX()
{
	int p_end = cv_PosX_to_HchX(get_CurEndPos());
	if (CurHchX==0 || p_end==0) {
		CurPos.x = 0; return;
	}

	int wp = ((CurHchX>p_end)? p_end : CurHchX) * HchWidth;
	int w = 0;
	UnicodeString lbuf = get_CurLine();
	for (int i=1; i<=lbuf.Length(); i++) {
		w = add_CharWidth(lbuf[i], w);
		if (w>wp) {
			CurPos.x = i - 1;	break;
		}
	}
}

//---------------------------------------------------------------------------
//J[\ʒuʃTQ[g獶
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::to_Lead_if_Trail(bool sel)
{
	if (CurPos.x>0 && get_DispLine(CurPos.y).IsTrailSurrogate(CurPos.x + 1)) CursorLeft(sel);
}

//---------------------------------------------------------------------------
//^uẢs܂ޕ̕\
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::TabTextOut(
	UnicodeString s,	//\
	TCanvas *cv,
	int &x,				//[io] XJnʒu (XV)
	int max_x)			//ő啝
{
	TColor fgcol = cv->Font->Color;
	int y = 0;
	int f_h = cv->TextHeight("Q");

	while (!s.IsEmpty()) {
		//䕶̈ʒu擾
		int ctrl_p = 0;
		for (int i=1; i<=s.Length() && ctrl_p==0; i++)
			if (iscntrl(s[i]) && s[i]!=_T('\r') && s[i]!=_T('\n')) ctrl_p = i;

		if (ctrl_p>0) {
			char ctrl_ch = s[ctrl_p];
			if (ctrl_p>1) {
				//^uO̕(ʏ\)
				UnicodeString sbuf = s.SubString(1, ctrl_p - 1);
				TRect rc = Rect(x, y, x + get_TextWidth(cv, sbuf, IsIrregFont), f_h);
				//r
				int hr_w = is_RuledLine(sbuf);
				if (hr_w>0) {
					cv->FillRect(rc);
					draw_Line(cv, rc.Left, rc.Top + rc.Height()/2, rc.Right, rc.Top + rc.Height()/2, hr_w, color_HR);
				}
				//
				else {
					cv->TextRect(rc, x, y, alt_BackSlash? ReplaceStr(s, "\\", _T("\u2216")) : s);
				}
				x += rc.Width();
			}
			//^u
			if (ctrl_ch==_T('\t')) {
				if (ShowTAB) draw_TAB(cv, x, y, HchWidth, f_h); else cv->TextOut(x, y, " ");
				x += HchWidth;
				int dt = (x - TopXpos) % TabWidth;
				if (dt>0) {
					int x1 = x + TabWidth - dt;
					while (x<x1) {
						cv->TextOut(x, y, " ");
						x += HchWidth;
						if (x>=max_x) break;
					}
				}
				s.Delete(1, ctrl_p);
			}
			//̑̐䕶
			else {
				cv->Font->Color = col_Ctrl;
				UnicodeString ctrl_str;  ctrl_str.sprintf(_T("%c"), ctrl_ch + 0x40);
				TRect rc = Rect(x, y, x + get_TextWidth(cv, ctrl_str, IsIrregFont), f_h);
				cv->TextRect(rc, x, y, ctrl_str);	x += get_TextWidth(cv, ctrl_str, IsIrregFont);
				s.Delete(1, ctrl_p);
				cv->Font->Color = fgcol;
			}
		}
		else {
			//ʏ\
			bool has_cr = has_CR(s);  if (has_cr) delete_end(s);
			TRect rc = Rect(x, y, x + get_TextWidth(cv, s, IsIrregFont), f_h);
			//r
			int hr_w = is_RuledLine(s);
			if (hr_w>0) {
				cv->FillRect(rc);
				draw_Line(cv, rc.Left, rc.Top + rc.Height()/2, rc.Right, rc.Top + rc.Height()/2, hr_w, color_HR);
			}
			//
			else {
				cv->TextRect(rc, x, y, alt_BackSlash? ReplaceStr(s, "\\", _T("\u2216")) : s);
			}
			x += rc.Width();

			//s
			if (has_cr) {
				if (ShowCR) draw_CR(cv, x, y, HchWidth, f_h); else cv->TextOut(x, y, " ");
			}
			s = EmptyStr;
		}
	}
}

//---------------------------------------------------------------------------
//`
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::PaintText()
{
	if (!isReady || !ViewBox->Parent->Showing) return;

	std::unique_ptr<Graphics::TBitmap> tmp_bmp(new Graphics::TBitmap());
	tmp_bmp->SetSize(ViewBox->ClientWidth - (ScrBar->Visible? 1 : 0), LineHeight);
	TRect    tmp_rc	= Rect(0, 0, tmp_bmp->Width, tmp_bmp->Height);
	TCanvas *tmp_cv = tmp_bmp->Canvas;
	TRect    img_rc = Rect(0, 0, tmp_bmp->Width, ViewBox->ClientHeight);
	tmp_cv->Font->Assign(ViewBox->Font);

	int fld_xp	= isFitWin ? tmp_bmp->Width
						   : (TopXpos + (isBinary? MaxHchX : ViewFoldWidth + 1) * HchWidth + 4);
	int top_idx = ScrBar->Position - 1;
	int d_idx	= top_idx - LastTop;
	int btm_idx	= top_idx + LineCount + 1;
	int adr_len = get_AddrStr(BinFileSize - 1).Length();

	WideChar strQch = '\0';

	//\
	bool mt_Case[MAX_EM_PTN] = {ReservedCase, false, isCase, false, false, false, UsrKeywdCase2};
	if (!isBinary && !isAozora && !isLog) mt_Case[5] = UsrKeywdCase;	//[U`L[[h̑召
	int  mt_Len[MAX_EM_PTN]  = {0, 0, 0, 0, 0, 0, 0};
	int  mt_Idx[MAX_EM_PTN]  = {0, 0, 0, 0, 0, 0, 0};

	EmPtn[2] = !isBytes && Highlight? RegExPtn : EmptyStr;	//

	int csr_yp = -1;
	int csr_xp = 0;
	int csr_bp = 0;
	int csr_lw = std::max(CursorWidth, 1);
	int csr_yl = FontHeight + csr_lw + 1;
	bool csr_eof = false;

	//obt@Ă镔`
	std::unique_ptr<Graphics::TBitmap> buf_bmp(new Graphics::TBitmap());
	buf_bmp->SetSize(img_rc.Width(), img_rc.Height());
	TCanvas *buffer_cv = buf_bmp->Canvas;

	int  buf_idx0, buf_idx1;
	bool buffered = (LastTop!=-1 && !ImgBuff->Empty && (abs(d_idx)<3));
	if (buffered) {
		TRect v_rc = img_rc;  OffsetRect(v_rc, 0, -(d_idx * LineHeight));
		buffer_cv->CopyRect( v_rc, ImgBuff->Canvas, img_rc);
		ViewCanvas->CopyRect(v_rc, ImgBuff->Canvas, img_rc);
		buf_idx0 = top_idx - d_idx;
		buf_idx1 = btm_idx - d_idx - 1;
	}

	//se̕`
	int v_yp = 0;
	for (int i=top_idx; i<=btm_idx; i++, v_yp+=LineHeight) {
		//]
		tmp_cv->Brush->Color = color_Margin;
		TRect bg_rc = tmp_rc;
		int rc_xp = 0;
		bg_rc.Right = rc_xp = LeftMargin;
		tmp_cv->FillRect(bg_rc);

		//sԍwi
		if ((ShowLineNo || isBinary)) {
			tmp_cv->Brush->Color = color_bgLineNo;
			bg_rc = tmp_rc;
			bg_rc.Left	= rc_xp;
			bg_rc.Right = rc_xp = TopXpos - TopMargin;
			tmp_cv->FillRect(bg_rc);
		}

		//wi
		tmp_cv->Brush->Color = color_bgView;
		bg_rc = tmp_rc;
		bg_rc.Left = rc_xp;
		if (isFitWin)
			tmp_cv->FillRect(bg_rc);
		else {
			rc_xp = (MarginBox && MarginBox->Width>0)? tmp_rc.Right : fld_xp + 4;
			bg_rc.Right = rc_xp;
			tmp_cv->FillRect(bg_rc);
			//E]
			if (rc_xp<tmp_rc.Right) {
				tmp_cv->Brush->Color = color_Margin;
				bg_rc = tmp_rc;
				bg_rc.Left = rc_xp;
				tmp_cv->FillRect(bg_rc);
				tmp_cv->Brush->Color = color_bgView;
			}
		}

		if (i<MaxDispLine) {
			line_rec *lp = get_LineRec(i);
			UnicodeString lbuf = get_DispLine(i);
			int lbuf_len = lbuf.Length();

			//J[\ʒu擾
			if (CurPos.y==i) {
				csr_yp = v_yp;
				csr_xp = TopXpos - 1 +
							(isBoxMode? CurHchX * HchWidth : get_StrWidth(lbuf.SubString(1, CurPos.x )));
				csr_eof = (i==MaxDispLine-1);
				//ΉAhXJ[\(oCi)
				if (isBinary) {
					int ofs = get_OfsR(CurPos.x);
					csr_bp = (CurPos.x<50)? (ofs + 50) : (ofs * 3 + ((ofs>7)? 1 : 0));
					csr_bp *= HchWidth;
					csr_bp += (TopXpos - 1);
				}
			}

			//svȕ`̓XLbv
			if (buffered && i>buf_idx0 && i<buf_idx1) {
				//sJ[\U`悵Ă
				if (CurPos.y==i && ShowLineCursor)
					draw_Line(ViewCanvas, LeftMargin + 1, v_yp + csr_yl, fld_xp - 2, v_yp + csr_yl, csr_lw, color_Cursor);

				//IȂ
				if (SelStart==SelEnd) {
					if		(!LastSel) continue;
					else if (LastPos.y==CurPos.y && CurPos.y!=i) continue;
				}
				//I
				else {
					if (LastPos.y==CurPos.y && CurPos.y!=i) {
						int y0 = std::min(SelStart.y, SelEnd.y);
						int y1 = std::max(SelStart.y, SelEnd.y);
						if (i<y0 || i>y1) continue;
					}
				}
			}

			int xp = TopXpos;
			if (i==MaxDispLine-1) {
				//t@C̏I
				out_Text(tmp_cv, xp, 0, isContinue? _T("ccc  ccc") : _T("[EOF]"), color_LineNo);
			}
			else {
				if (lp->LineIdx==0) {
					int x0 = LeftMargin + MARK_WIDTH;
					//sԍ/AhX
					if ((ShowLineNo || isBinary)) {
						UnicodeString ln_str;
						//AhX
						if (isBinary) {
							if (lp->LineNo>0) ln_str = get_AddrStr(TopAddress + i*16, adr_len);
						}
						//sԍ
						else {
							if (lp->LineNo>0) ln_str.sprintf(_T("%6u"), lp->LineNo);
						}
						tmp_cv->Brush->Color = color_bgLineNo;
						tmp_cv->Font->Color  = color_LineNo;
						tmp_cv->TextOut(x0, 0, ln_str);
					}
					//}[N
					if (IsMarked(lp->LineNo)) {
						tmp_cv->Brush->Color = color_Mark;
						tmp_cv->FillRect(Rect(LeftMargin, tmp_rc.Top, x0 - 2, tmp_rc.Top + FontHeight + 1));
					}
					tmp_cv->Brush->Color = color_bgView;
				}

				//e
				int q0 = -1, q1 = -1;
				//I
				if (SelStart!=SelEnd) {
					//`I
					if (isBoxMode) {
						TPoint sp0 = BoxStart;
						TPoint sp1 = BoxEnd;
						bool flag = (sp0.y==sp1.y)? (sp0.x>sp1.x) : (sp0.y>sp1.y);
						if (flag) std::swap(sp0, sp1);
						if (sp0.x>sp1.x) std::swap(sp0.x, sp1.x);
						if (lp->LineIdx==0 && sp0.y<=i && i<=sp1.y) {
							int wp0 = sp0.x * HchWidth;
							int wp1 = sp1.x * HchWidth;
							int w = 0;
							for (int j=1; j<=lbuf_len; j++) {
								w = add_CharWidth(lbuf[j], w);
								if (w>wp1) break;
								if (w>wp0) {
									if (q0==-1) q0 = j;
									q1 = j;
								}
							}
						}
					}
					//ʏI
					else {
						TPoint sp0 = SelStart;
						TPoint sp1 = SelEnd;
						bool flag = (sp0.y==sp1.y)? (sp0.x>sp1.x) : (sp0.y>sp1.y);
						if (flag) std::swap(sp0, sp1);
						if (sp0.y==i) {
							q0 = sp0.x + 1;
							q1 = (sp1.y==i)? sp1.x : lbuf_len;
						}
						else if (sp1.y==i) {
							q0 = 1;
							q1 = sp1.x;
						}
						else if (sp0.y<i && i<sp1.y) {
							q0 = 1;
							q1 = lbuf_len;
						}
					}
				}

				//obt@
				TColor curFgCol[4096], curBgCol[4096];

				//IF
				for (int j=1; j<=lbuf_len; j++) {
					curFgCol[j] = color_fgView;
					curBgCol[j] = (q0<=j && j<=q1)? color_selItem : color_bgView;
				}

				UnicodeString lbuf2 = lbuf;
				if (isText) {
					//ݍsss܂ł̓e擾
					for (int i2=i+1; i2<MaxDispLine; i2++) {
						if (has_CR(lbuf2)) break;
						if (get_LineRec(i2)->LineIdx==0) break;
						lbuf2.cat_sprintf(_T("%s"), get_DispLine(i2).c_str());
						if (lbuf2.Length()>4096) break;		//***
					}

					//o
					if (!HeadlinePtn.IsEmpty()) {
						if (lp->LineIdx==0 || HeadlinePtn[1]!='^') {
							TMatch mt = TRegEx::Match(lbuf, HeadlinePtn);
							if (mt.Success) {
								int mlen = isLog? mt.Length : lbuf_len;
								for (int j=1; j<=mlen; j++) curFgCol[j] = color_Headline;
								if (isLog) {
									int p = lbuf.Pos("--->");
									if (p>0) {
										for (int j=0; j<4; j++) curFgCol[p++] = color_Symbol;
									}
								}
							}
						}
					}

					//Rg
					if (lp->RemPos0>0) for (int j=lp->RemPos0; j<=lp->RemPos1; j++) curFgCol[j] = color_Comment;

					//
					if (!QuotStr.IsEmpty()) {
						if (!lbuf.IsEmpty()) {
							bool isEsc = false;
							WideChar c1 = lbuf[1];
							bool isQ = ContainsText(QuotStr, c1);
							if (useEsc && c1=='\\') isEsc = true;
							strQch = lp->topQch;
							if (curFgCol[1]!=color_Comment && (strQch!='\0' || isQ)) curFgCol[1] = color_Strings;
							for (int j=2; j<=lbuf_len; j++) {
								WideChar cj = lbuf[j];
								bool isQ = ContainsText(QuotStr, cj);
								if		(isEsc)				 isEsc = false;
								else if (useEsc && cj=='\\') isEsc = true;
								else if (isQ)				 strQch = (strQch==cj)? '\0' : cj;
								TColor *fg = &curFgCol[j];
								if (*fg==color_Comment) continue;
								if (strQch!='\0' || isQ) *fg = color_Strings;
							}
							if (lp->hasCR) strQch = '\0';
						}
						else strQch = '\0';
					}

					//V{
					if (!SymbolChs.IsEmpty()) {
						for (int j=1; j<=lbuf_len; j++) {
							TColor *fg = &curFgCol[j];
							if (*fg==color_Comment || *fg==color_Strings) continue;
							if (lbuf.IsDelimiter(SymbolChs, j)) *fg = color_Symbol;
						}
					}
				}

				//\AURLA[Jt@CA}b`̋\
				for (int i_p=0; i_p<MAX_EM_PTN; i_p++) {
					if (EmPtn[i_p].IsEmpty()) continue;

					//Os̑
					if (mt_Idx[i_p]>0 && mt_Len[i_p]>0) {
						if (mt_Idx[i_p]<=lbuf_len) {
							for (int i_x=mt_Idx[i_p]; mt_Len[i_p]>0 && i_x<=lbuf_len; i_x++,mt_Len[i_p]--) {
								TColor *fg = &curFgCol[i_x];
								if (*fg!=color_Comment && *fg!=color_Strings) *fg = EmFgC[i_p];
								TColor *bg = &curBgCol[i_x];
								if (EmBgC[i_p]!=clNone && *bg!=color_selItem) *bg = EmBgC[i_p];
							}
							mt_Idx[i_p] = (mt_Len[i_p]>0)? 1 : 0;
						}
						else
							mt_Idx[i_p] -= lbuf_len;
						if (lp->hasCR) mt_Len[i_p] = 0;
					}

					//K\ŋ
					if (!lbuf2.IsEmpty() && (lp->LineIdx==0 || EmPtn[i_p][1]!='^')) {
						if (i_p==1 && lbuf2.Pos(':')==0) continue;	//URL ԒZk̂߂̑O`FbN

						TRegExOptions opt;
						if (!mt_Case[i_p]) opt << roIgnoreCase;
						TMatchCollection mts = TRegEx::Matches(lbuf2, EmPtn[i_p], opt);
						mt_Len[i_p] = 0;
						for (int i_m=0; i_m<mts.Count; i_m++) {
							mt_Len[i_p] = mts.Item[i_m].Length;
							mt_Idx[i_p] = mts.Item[i_m].Index;
							if (mt_Idx[i_p]<=lbuf_len) {
								for (int i_x=mt_Idx[i_p]; mt_Len[i_p]>0 && i_x<=lbuf_len; i_x++,mt_Len[i_p]--) {
									//
									TColor *fg = &curFgCol[i_x];
									if (EmFgC[i_p]==color_URL)		//URLD
										*fg = EmFgC[i_p];
									else if (*fg!=color_Comment && *fg!=color_Strings && *fg!=color_URL && (isText || i_x<50))
										*fg = EmFgC[i_p];
									//wi
									TColor *bg = &curBgCol[i_x];
									if (EmBgC[i_p]!=clNone && *bg!=color_selItem) *bg = EmBgC[i_p];
								}
								if (mt_Len[i_p]>0) {
									mt_Idx[i_p] = 1; break;	//sɑ
								}
								else
									mt_Idx[i_p] = 0;
							}
							else {
								mt_Idx[i_p] -= lbuf_len;  break;
							}
						}
					}
				}

				//INIt@C̃L[Ɛl\
				if (isIniFmt && lp->LineIdx==0) {
					int p = lbuf.Pos('=');
					if (p>1 && curFgCol[1]!=color_Comment && curFgCol[1]!=color_Headline) {
						//L[
						for (int i_x=1; i_x<p; i_x++) curFgCol[i_x] = color_Reserved;
						// =
						curFgCol[p++] = color_Symbol;
						//l
						UnicodeString sbuf = TrimRight(lbuf);
						if ((sbuf.Length() - p + 1) <= 20) {
							bool flag = true;
							for (int i_x=p; i_x<=sbuf.Length() && flag; i_x++)
								flag = iswdigit(sbuf[i_x]) || (i_x==p && sbuf[i_x]=='-');
							if (flag) for (int i_x=p; i_x<=sbuf.Length(); i_x++) curFgCol[i_x] = color_Numeric;
						}
					}
				}

				//oCiASCIIɔf
				if (isBinary) {
					int i_x = 1;
					for (int i_h=0; i_h<16; i_h++) {
						if (curFgCol[i_x]==curFgCol[i_x + 1]) curFgCol[51 + i_h] = curFgCol[i_x];
						i_x += 3; if (i_h==7) i_x++;
					}
				}

				//`
				if (color_fgSelItem!=clNone) {
					for (int j=1; j<=lbuf_len; j++)
						if (curBgCol[j]==color_selItem) curFgCol[j] = color_fgSelItem;
				}
				tmp_cv->Font->Color  = curFgCol[1];
				tmp_cv->Brush->Color = curBgCol[1];
				UnicodeString sbuf;
				for (int j=1; j<=lbuf_len; j++) {
					TColor *fg = &curFgCol[j];
					TColor *bg = &curBgCol[j];
					if (*fg==tmp_cv->Font->Color && *bg==tmp_cv->Brush->Color)
						sbuf.cat_sprintf(_T("%c"), lbuf[j]);
					else {
						TabTextOut(sbuf, tmp_cv, xp, fld_xp);
						sbuf = lbuf[j];
						tmp_cv->Font->Color  = *fg;
						tmp_cv->Brush->Color = *bg;
					}
				}
				if (!sbuf.IsEmpty()) TabTextOut(sbuf, tmp_cv, xp, fld_xp);

				//Œ蒷\̏cr
				if (isFixedLen && lp->LineIdx==0 && FixWdList.Length>0 && color_bdrFixed!=clNone) {
					int v_xp = TopXpos;
					for (int j=0; j<FixWdList.Length-1; j++) {
						v_xp += (FixWdList[j] + 1) * HchWidth;
						if (v_xp>fld_xp) break;
						draw_Line(tmp_cv, v_xp, 0, v_xp, LineHeight, 1, color_bdrFixed);
						v_xp += HchWidth;
					}
				}
			}
		}

		//sԍE
		if ((ShowLineNo || isBinary) && color_bdrLine!=clNone)
			draw_Line(tmp_cv, TopXpos - TopMargin, 0, TopXpos - TopMargin, LineHeight, 1, color_bdrLine);
		//܂ԂE
		if (!isFitWin && color_bdrFold!=clNone)
			draw_Line(tmp_cv, fld_xp, 0, fld_xp, LineHeight, 1, color_bdrFold);

		//obt@ɕ`
		TRect v_rc = tmp_rc;  OffsetRect(v_rc, 0, v_yp);
		buffer_cv->CopyRect(v_rc, tmp_bmp->Canvas, tmp_rc);
		//sJ[\U`悵Ă
		if (CurPos.y==i && ShowLineCursor)
			draw_Line(tmp_cv, LeftMargin + 1, csr_yl, fld_xp - 2, csr_yl, csr_lw, color_Cursor);
		ViewCanvas->CopyRect(v_rc, tmp_cv, tmp_rc);
	}

	//݂̉ʂobt@ɃRs[
	ImgBuff->SetSize(img_rc.Width(), img_rc.Height());
	ImgBuff->Canvas->CopyRect(img_rc, buffer_cv, img_rc);

	if (csr_yp>=0) {
		int yp_l = csr_yp + csr_yl;
		//sJ[\
		if (ShowLineCursor)
			draw_Line(ViewCanvas, LeftMargin + 1, yp_l, fld_xp - 2, yp_l, csr_lw, color_Cursor);
		//J[\
		draw_Line(ViewCanvas, csr_xp, csr_yp, csr_xp, yp_l - 1, 2, color_Cursor);
		//ΉAhXJ[\
		if (isBinary)
			draw_Line(ViewCanvas, csr_bp, yp_l - LineHeight/2, csr_bp, yp_l - 1, 1, color_Cursor);

		//Œ蒷\̃ZwiAt@
		if (!csr_eof && isFixedLen && FixWdList.Length>0 && CellAlpha>0 &&
			CsvCol>=0 && CsvCol<FixWdList.Length)
		{
			int a_xp = TopXpos;
			for (int j=0; j<CsvCol; j++) a_xp += (FixWdList[j] + 2) * HchWidth;
			int a_wd = (FixWdList[CsvCol] + 2) * HchWidth;
			if (CsvCol==0) a_xp -= TopMargin; else a_xp -= HchWidth;
			a_xp++; a_wd--;
			if (a_xp<fld_xp) {
				BLENDFUNCTION blend_f;
				blend_f.BlendOp             = AC_SRC_OVER;
				blend_f.BlendFlags          = 0;
				blend_f.SourceConstantAlpha = CellAlpha;
				blend_f.AlphaFormat         = 0;

				std::unique_ptr<Graphics::TBitmap> bp_b(new Graphics::TBitmap());
				bp_b->SetSize(8, 8);
				bp_b->Canvas->Brush->Style = bsSolid;
				bp_b->Canvas->Brush->Color = color_Cursor;
				bp_b->Canvas->FillRect(TRect(0, 0, 8, 8));
				::AlphaBlend(ViewCanvas->Handle, a_xp, csr_yp, a_wd, LineHeight, bp_b->Canvas->Handle, 0, 0, 8, 8, blend_f);
			}
		}
	}

	LastPos = CurPos;
	LastTop = top_idx;
	LastSel = (SelStart!=SelEnd);
}

//---------------------------------------------------------------------------
//[̕`
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onRulerPaint(TObject *Sender)
{
	if (!isReady) return;

	TCanvas *cv = RulerBox->Canvas;
	TRect rc = RulerBox->ClientRect;
	cv->Brush->Color = color_bgRuler;
	cv->FillRect(rc);

	cv->Pen->Color = color_fgRuler;
	cv->Pen->Width = 1;
	cv->Font->Assign(DialogFont);
	cv->Font->Color = color_fgRuler;
	int xp = TopXpos - 1;

	//Œ蒷\
	if (isCSV && isFixedLen && FixWdList.Length>0) {
		cv->Font->Height = RulerBox->ClientHeight - 2;
		for (int i=0; i<FixWdList.Length; i++) {
			if (i==0) {
				cv->MoveTo(xp, rc.Top + 2);
				cv->LineTo(xp, rc.Bottom - 1);
			}
			UnicodeString c;
			if (i<26)
				c.sprintf(_T("%c"), 'A' + i);
			else
				c.sprintf(_T("%c%c"), 'A' + i/26 - 1, 'A' + i%26);
			cv->TextOut(xp + 4, rc.Top, c);

			if (i==0) xp -= (HchWidth - 1);
			xp += ((FixWdList[i] + 2) * HchWidth);
			cv->MoveTo(xp, rc.Top + 2);
			cv->LineTo(xp, rc.Bottom - 1);
		}
	}
	//oCi
	else if (isBinary) {
		cv->Font->Assign(ViewBox->Font);
		cv->Font->Color  = color_fgRuler;
		cv->Font->Height = std::min(RulerBox->ClientHeight, abs(cv->Font->Height)) - 2;
		UnicodeString tmp;
		for (int i=0; i<16; i++) {
			tmp.sprintf(_T("+%X"), i);
			cv->TextOut(xp + HchWidth*2 - cv->TextWidth(tmp), rc.Top, tmp);
			xp += HchWidth * ((i==7)? 4 : 3);
		}
		xp += HchWidth;
		for (int i=0; i<16; i++) {
			tmp.sprintf(_T("%X"), i);
			cv->TextOut(xp + HchWidth - cv->TextWidth(tmp), rc.Top, tmp);
			xp += HchWidth;
		}
	}
	//ʏ\
	else {
		cv->Font->Height = 10;
		//ڐ
		for (int i=0; i<MaxFoldWd; i++) {
			if (i%10==0) {
				cv->MoveTo(xp, rc.Top + 2);
				cv->LineTo(xp, rc.Bottom - 1);
				cv->TextOut(xp + 2, rc.Top, i);
			}
			else {
				cv->MoveTo(xp, rc.Bottom - 4);
				cv->LineTo(xp, rc.Bottom - 1);
			}
			xp += HchWidth;
		}
	}

	//܂Ԃʒu
	if (!isFitWin && !isBinary) {
		xp = TopXpos + ViewFoldWidth * HchWidth - 1;
		TPoint mkp[3] = {Point(xp, rc.Bottom - 1), Point(xp - 3, rc.Bottom - 6), Point(xp + 3, rc.Bottom - 6)};
		cv->Brush->Style = bsSolid;
		cv->Brush->Color = color_fgRuler;
		cv->Polygon(mkp, 2);
	}

	//J[\ʒu
	xp = TopXpos + cv_PosX_to_HchX(CurPos.x) * HchWidth - 1;
	draw_Line(cv, xp, rc.Top + 1, xp, rc.Bottom, 2, color_fgRuler);
}

//---------------------------------------------------------------------------
//ĕ`v
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::Repaint(bool force)
{
	if (inh_Repaint) return;

	if (force) {
		LastPos = Point(-1, -1);
		LastTop = -1;
	}

	PaintText();

	if (RulerBox->Visible) RulerBox->Repaint();
}

//---------------------------------------------------------------------------
void __fastcall TTxtViewer::Clear()
{
	ViewBox->Font->Assign(ViewerFont);
	useFontName = ViewerFont->Name;
	useFontSize = ViewerFont->Size;

	isReady    = false;

	isSelected = false;
	isText	   = isBinary = isXDoc2Txt = false;
	isCSV	   = isTSV    = false;
	isClip	   = false;
	isTail	   = false;
	isAozora   = isLog = isIniFmt = isAwstats = false;

	isIncSea   = false;
	IncSeaWord = EmptyStr;

	FindWord   = RegExPtn = EmptyStr;

	HasBOM = false;
	LineBreakStr = EmptyStr;

	MMF->Close();

	ImgBuff->Handle = NULL;

	LastPos = Point(-1, -1);
	LastTop = -1;
	LastSel = false;

	if (FileRec) {
		del_file_rec(FileRec);
		FileRec = NULL;
	}

	SetColor();
	TabLength = 0;
}

//---------------------------------------------------------------------------
//sE̐K
//---------------------------------------------------------------------------
TPoint __fastcall TTxtViewer::nrm_Pos(TPoint p)
{
	if (p.x<0) {
		//ݍsO
		for (;;) {
			p.y--;
			if (p.y<0) {
				p = Point(0, 0);  break;
			}
			p.x += get_DispLine(p.y).Length();
			if (p.x>0) break;
		}
	}
	else if (p.y<MaxDispLine) {
		for (;;) {
			int end_p = get_DispLine(p.y).Length();
			if (p.x<=end_p) break;
			p.x -= end_p;
			p.y++;
			if (p.y>=MaxDispLine) {
				p.y = MaxDispLine - 1;
				UnicodeString lbuf = get_DispLine(p.y);
				p.x = lbuf.Length();	if (has_CR(lbuf)) p.x--;
				break;
			}
		}
	}
	return p;
}

//---------------------------------------------------------------------------
//IԂ̏
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::IniSelected(bool sel)
{
	if (!sel || SelStart==SelEnd) {
		if (!sel) isSelMode = isBoxMode = false;
		SelStart = BoxStart = CurPos;
		BoxStart.x = cv_PosX_to_HchX(BoxStart.x);
		set_SelEnd();
	}
}

//---------------------------------------------------------------------------
//ʈʒusEݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetPosFromPt(int x, int y)
{
	y += (ScrBar->Position - 1) * LineHeight;
	x -= TopXpos;

	if (x<0) x = 0;
	if (y<0) y = 0;

	//s
	int n = y / LineHeight;
	if (n>=MaxDispLine) n = MaxDispLine - 1;
	CurPos.y = n;

	//
	int xp = -1;
	UnicodeString lbuf = get_CurLine();
	for (int i=1; i<=lbuf.Length(); i++) {
		int w = get_StrWidth(lbuf.SubString(1, i));
		if (x<=w) {
			xp = i - 1;
			if (lbuf.IsTrailSurrogate(i)) xp--;
			break;
		}
	}

	if (xp==-1) {
		ExtClicked = true;		//sオNbNꂽ
		xp = lbuf.Length();
	}
	else
		ExtClicked = false;

	CurPos.x = xp;
	CurHchX  = cv_PosX_to_HchX(CurPos.x);

	set_CurCsvCol();
}
//---------------------------------------------------------------------------
//|CgI͈͓ɂ邩?
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::PtInSelected(int x, int y)
{
	if (SelStart==SelEnd) return false;

	y += (ScrBar->Position - 1) * LineHeight;
	x -= TopXpos;
	if (y<0 || x<0) return false;

	//s
	int py = y / LineHeight;
	if (py<SelStart.y || py>SelEnd.y) return false;

	//
	UnicodeString lbuf = get_DispLine(py);
	int px = -1;
	for (int i=1; i<=lbuf.Length(); i++) {
		int w = get_StrWidth(lbuf.SubString(1, i));
		if (x<=w) {
			px = i - 1;
			if (lbuf.IsTrailSurrogate(i)) px--;
			break;
		}
	}

	if (px==-1) return false;
	if (py==SelStart.y && px<SelStart.x) return false;
	if (py==SelEnd.y   && px>=SelEnd.x)  return false;
	return true;
}

//---------------------------------------------------------------------------
void __fastcall TTxtViewer::UpdatePos(
	bool up_pos,		// (default = false)
	bool force)			// (default = false)
{
	LineCount = ViewBox->ClientHeight / LineHeight - 1;

	if (up_pos) {
		CurTop = CurPos.y - 5;
		if (CurTop<1) CurTop = 1;
		CurTop = std::min(CurTop, ScrBar->Max - ScrBar->LargeChange - 1);
		ScrBar->Position = CurTop;
	}
	else
		CurTop = ScrBar->Position;

	CurBottom = CurTop + LineCount;

	bool changed = false;
	if (CurPos.y<CurTop) {
		CurTop	  = CurPos.y;
		CurBottom = CurTop + LineCount;
		changed = true;
	}
	else if (CurPos.y >= CurBottom-1) {
		CurBottom = CurPos.y + 1;
		CurTop = CurBottom - LineCount;
		if (CurTop<1) {
			CurTop	  = 1;
			CurBottom = CurTop + LineCount;
		}
		changed = true;
	}
	if (changed) ScrBar->Position = CurTop;

	set_CurCsvCol();

	Repaint(force);

	//C[Wvr[
	if (GifViewer->Visible) {
		UnicodeString fnam = GetCurImgFile();
		if (!fnam.IsEmpty() && !SameText(GifViewer->FileName, fnam)) GifViewer->DrawImage(fnam);
	}
}

//---------------------------------------------------------------------------
//J[\\͈͊OɂȂĂAʒuֈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::UpdateVisible()
{
	CurTop	  = ScrBar->Position;
	CurBottom = CurTop + LineCount;
	if (CurPos.y<CurTop || CurPos.y>CurBottom) UpdatePos(true);
}

//---------------------------------------------------------------------------
//ԕ\ݒ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SetSttInf(UnicodeString msg)
{
	if (!isReady) return;

	//[
	if (RulerBox && RulerBox->Visible) RulerBox->Repaint();

	//Xe[^X
	if (SttHeader) {
		UnicodeString fext = get_extension(FileName);

		//t@C/CN^T[`
		SttHeader->Panels->Items[0]->Text
			= !msg.IsEmpty()? msg : isIncSea? ((isIncMigemo? " Migemo: " : " T[`: ") + IncSeaWord) : SttHdrInf;

		//R[h
		UnicodeString sttstr;
		sttstr = (!isXDoc2Txt && !test_FileExt(fext, _T(".rtf")) && isText)?
					get_NameOfCodePage(TxtBufList->Encoding->CodePage, false, HasBOM) : UnicodeString("----");
		SttHeader->Panels->Items[1]->Text = sttstr;

		//sR[h
		SttHeader->Panels->Items[2]->Text = !isXDoc2Txt? LineBreakStr : UnicodeString("--");

		//
		if		(isXDoc2Txt)							sttstr.USET_T("XD2TX");
		else if (isBinary)								sttstr.USET_T("BINARY");
		else if (test_HtmlExt(fext))					sttstr.sprintf(_T("%s"), isHtm2Txt?  _T("TEXT") : _T("SOURCE"));
		else if (isCSV) {
			sttstr.sprintf(_T("%s"), isTSV? _T("TSV") : _T("CSV"));
			if (isFixedLen) sttstr.Insert("FIXED - ", 1);
		}
		else if (test_FileExt(fext, _T(".rtf.wri")))	sttstr.USET_T("PLAIN");
		else if (isAozora)								sttstr.USET_T("󕶌");
		else if (isLog)									sttstr.USET_T("LOG");
		else if (isTail)								sttstr.USET_T("TAIL");
		else											sttstr.USET_T("TEXT");

		//[UZNV(fobO\)
		if (LogDebugInf) {
			UnicodeString sct = UserHighlight->CurSection;
			if (!sct.IsEmpty()) {
				if (sct.Pos(':')) {
					sct = get_tkn_r(sct, ":");
					if (sct.IsEmpty()) sct = "*";
				}
				sttstr.cat_sprintf(_T(":%s"), sct.c_str());
			}
		}

		SttHeader->Panels->Items[3]->Text = sttstr;

		sttstr = EmptyStr;
		//AhX
		if (isBinary) {
			__int64 adr = get_CurAddrA();
			sttstr.sprintf(_T("%s/%s"), get_AddrStr(adr).c_str(), get_AddrStr(BinFileSize - 1).c_str());
		}
		//s
		else {
			TPoint clp = get_CurLinePos();
			sttstr.cat_sprintf(_T("%5us %4u"), clp.y, clp.x);
			if (isCSV && CsvCol>=0) sttstr.cat_sprintf(_T("  %u"), CsvCol + 1);
			//I
			if (SelStart!=SelEnd) {
				if (!isBoxMode && SelStart.x==0 && SelEnd.x==0)
					sttstr.cat_sprintf(_T(" %4usI"), abs((int)(SelEnd.y - SelStart.y)));
				else
					sttstr.cat_sprintf(_T(" %4uI"), str_len_unicode(get_SelText()));
			}
			else if (isCSV && isFixedLen && TopIsHeader && TxtBufList->Count>0) {
				UnicodeString top_str = TxtBufList->Strings[0];
				sttstr.cat_sprintf(_T(" [%s]"), (isTSV? get_tsv_item(top_str, CsvCol) : get_csv_item(top_str, CsvCol)).c_str());
			}
		}

		SttHeader->Panels->Items[4]->Text = sttstr;

		//J[
		if (isText && TxtColorHint && ColorPanel && SelStart==SelEnd) {
			int xp;
			UnicodeString colstr = GetCurWord(false,
					"(#[0-9a-fA-F]{3}\\b)|(#[0-9a-fA-F]{6}\\b)|"
					"(0x|\\$)[0-9a-fA-F]{6,8}|"
					"(=[0-9a-fA-F]{6})", &xp);

			colstr = REPLACE_TS(colstr, "$", "0x");
			int col = -1;
			//HTML
			if (remove_top_s(colstr, '#')) {
				UnicodeString r_str, g_str, b_str;
				if (colstr.Length()==6) {
					r_str = colstr.SubString(1, 2);
					g_str = colstr.SubString(3, 2);
					b_str = colstr.SubString(5, 2);
				}
				else if (colstr.Length()==3) {
					r_str = StringOfChar(colstr[1], 2);
					g_str = StringOfChar(colstr[2], 2);
					b_str = StringOfChar(colstr[3], 2);
				}
				colstr.sprintf(_T("0x00%s%s%s"), b_str.c_str(), g_str.c_str(), r_str.c_str());
				col = colstr.ToIntDef(-1);
			}
			//COLORREF
			else if (StartsStr("0x", colstr)) {
				col = colstr.ToIntDef(-1);
			}
			//Swatchbook.INI (RRBBGG)
			else if (remove_top_s(colstr, '=') && SameText(ExtractFileName(FileName), SWATCH_FILE)) {
				col = (int)xRRGGBB_to_col(colstr);
			}

			if (col!=-1) {
				ColorPanel->Color	= TColor(col);
				ColorPanel->Left	= TopXpos + cv_PosX_to_HchX(xp + 1) * HchWidth;
				ColorPanel->Top 	= ViewBox->Top + (CurPos.y - CurTop + 1) * LineHeight;
				ColorPanel->Visible = true;
			}
			else
				ColorPanel->Visible = false;
		}
	}

	//
	if (isText && CharInfoForm->Visible) {
		UnicodeString chstr;
		UnicodeString lnstr = get_DispLine(CurPos.y);
		int p = CurPos.x;
		if (p<lnstr.Length()) {
			chstr = lnstr[++p];
			if (lnstr.IsLeadSurrogate(p) && p<lnstr.Length())
				chstr += lnstr[++p];
			else if (lnstr.IsTrailSurrogate(p))
				chstr = EmptyStr;
		}
		CharInfoForm->UpdateChar(chstr);
	}

	//CSV/TSVR[h
	if (isText && CsvRecForm->Visible) {
		line_rec *lp = get_LineRec(CurPos.y);
		if (lp->LineIdx==0 && lp->LineNo>0) CsvRecForm->UpdateRecord(TxtBufList, lp->LineNo - 1, CsvCol);
	}

	//CXyN^
	if (isBinary) {
		if (InspectForm->Visible) {
			__int64 adr = get_CurAddrA();
			if (adr>=0) {
				InspectForm->Address = adr;
				unsigned int adr_r = adr - TopAddress;
				int cnt = std::min(128U, BinarySize - adr_r);	//***
				InspectForm->Bytes.Length = cnt;
				for (int i=0; i<cnt; i++) InspectForm->Bytes[i] = MMF->Bytes[adr_r + i];
			}
			else {
				InspectForm->Address = 0;
				InspectForm->Bytes.Length = 0;
			}
			InspectForm->UpdateValue();
		}
	}
}

//---------------------------------------------------------------------------
//gÕR}hp[^Őݒ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SetToggleSw(bool &sw, UnicodeString prm)
{
	sw = USAME_TI(prm, "ON")? true : USAME_TI(prm, "OFF")? false : !sw;
	return sw;
}

//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onMouseDown(int x, int y)
{
	if (SelSkip) {
		SelSkip = false;
		return;
	}

	if (PtInSelected(x, y)) {
		PtInSelect = true;
	}
	else {
		IniSelected();

		SetPosFromPt(x, y);
		to_Lead_if_Trail();

		IniSelected(true);
		Repaint(true);
		SetSttInf();
		Selecting = true;

		//C[Wvr[
		if (GifViewer->Visible) {
			UnicodeString fnam = GetCurImgFile();
			if (!fnam.IsEmpty() && !SameText(GifViewer->FileName, fnam)) GifViewer->DrawImage(fnam);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onMouseMove(int x, int y)
{
	if (PtInSelect) {
		UnicodeString tmp = Clipboard()->AsText;
		Clipboard()->AsText = get_SelText();
		usr_SH->DoClipDragDrop();
		Clipboard()->AsText = tmp;
		PtInSelect = false;
	}
	else if (Selecting) {
		SetPosFromPt(x, y);
		SelEnd = CurPos;
		Repaint();
		SetSttInf();
	}
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onMouseUp()
{
	Selecting = PtInSelect = false;
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onDblClick()
{
	TPoint p = ViewBox->ScreenToClient(Mouse->CursorPos);
	//]/sԍ
	if (p.x<TopXpos)
		//sI(sP)
		SelLine(true);
	//{
	else {
		UnicodeString lbuf   = get_SelText();	if (lbuf.IsEmpty()) lbuf = get_CurLine(true);
		UnicodeString urlstr = ClickableUrl? extract_URL(lbuf) : EmptyStr;
		//URLJ
		if (!urlstr.IsEmpty())
			Execute_ex(urlstr);
		//J[\ʒu̒PI
		else
			GetCurWord(true);
	}

	SelSkip = true;	//DblClick̑I
}
//---------------------------------------------------------------------------
//[̃}EX
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::onRulerDblClick(TObject *Sender)
{
	if (!RulerBox || isBinary) return;

	TPoint p = RulerBox->ScreenToClient(Mouse->CursorPos);
	int wd = (p.x >= TopXpos)? (p.x - TopXpos)/HchWidth : 0;
	ViewFoldFitWin = (wd==0);
	if (!ViewFoldFitWin) ViewFoldWidth = wd;

	UpdateScr(get_CurLineNo());
}

//---------------------------------------------------------------------------
//J[\ړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::CursorLeft(bool sel)
{
	if (isBinary && !sel && TopAddress>0 && get_CurAddrR()==0) {
		CursorUp(); LineEnd();
	}
	else {
		IniSelected(sel);

		int dx = -1;
		if (isBinary) {
			if (CurPos.x<=50) {
				int p = CurPos.x;  if (p>=24) p--;
				p = (p/3 - 1)*3;  if (p>=24) p++;
				dx = p - CurPos.x;
			}
		}
		else {
			if (CurPos.x>0 && get_DispLine(CurPos.y).IsTrailSurrogate(CurPos.x)) dx--;
		}

		int n = CurPos.x + dx;
		if (n<0) {
			if (CurPos.y>0) {
				CurPos.y--;
				n = get_CurEndPos();
			}
			else n = 0;
		}
		CurPos.x = n;
		CurHchX = cv_PosX_to_HchX(CurPos.x);

		if (sel) set_SelEnd();
		UpdatePos();
	}
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::CursorRight(bool sel)
{
	if (isBinary && !sel && isContinue && get_CurAddrR()==BinarySize-1) {
		CursorDown(); LineTop();
	}
	else {
		IniSelected(sel);

		int dx = 1;
		if (isBinary) {
			if (CurPos.x<50) {
				int p = CurPos.x;  if (p>=24) p--;
				p /= 3;
				if (p==15) p = 50;
				else {
					p = (p + 1)*3;  if (p>=24) p++;
				}
				dx = p - CurPos.x;
			}
		}
		else {
			UnicodeString lnstr = get_DispLine(CurPos.y);
			if (CurPos.x<lnstr.Length() && lnstr.IsLeadSurrogate(CurPos.x + 1)) dx++;
		}

		if (isBoxMode) {
			if (CurHchX<MaxHchX) CurPos.x += dx;
		}
		else {
			int n = CurPos.x + dx;
			if (n>get_CurEndPos()) {
				if (CurPos.y < MaxDispLine - (CsvRecForm->Visible? 2: 1)) {
					//s
					CurPos.y++;
					n = 0;
				}
				else n = CurPos.x;
			}
			CurPos.x = n;
		}
		CurHchX = cv_PosX_to_HchX(CurPos.x);

		if (sel) set_SelEnd();
		UpdatePos();
	}
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::CursorUp(bool sel, UnicodeString prm)
{
	int n = get_MovePrm(prm);

	if (isBinary && !sel && CurPos.y==0 && TopAddress>0) {
		__int64 lst_adr = get_CurAddrA();
		__int64 adr = std::max<__int64>(TopAddress - ViewBinLimitSize, 0);
		AssignBin(adr, true);
		ToAddrR(lst_adr - 16*n - TopAddress);
	}
	else {
		UpdateVisible();
		if (CsvRecForm->Visible && n==1 && !isFixedLen)
			MoveLineTop(false, sel);
		else {
			IniSelected(sel);
			for (int i=0; i<n && CurPos.y>0; i++) CurPos.y--;
			adjust_PosX();
			if (sel) set_SelEnd();
			UpdatePos();
			to_Lead_if_Trail(sel);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::CursorDown(bool sel, UnicodeString prm)
{
	int n = get_MovePrm(prm);

	if (isBinary && !sel && isContinue && (CurPos.y >= MaxDispLine-2)) {
		__int64 lst_adr = get_CurAddrA();
		AssignBin(TopAddress + BinarySize, true);
		ToAddrR(lst_adr + 16*n - TopAddress);
	}
	else {
		UpdateVisible();
		if (CsvRecForm->Visible && n==1 && !isFixedLen) {
			if (CurPos.y < MaxDispLine-2) MoveLineTop(true, sel);
		}
		else {
			IniSelected(sel);
			for (int i=0; i<n && CurPos.y<MaxDispLine-1; i++) CurPos.y++;
			adjust_PosX();
			if (sel) set_SelEnd();
			UpdatePos();
			to_Lead_if_Trail(sel);
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TTxtViewer::MovePage(bool is_down, bool sel)
{
	UpdateVisible();

	int r = CurPos.y - CurTop;
	int n = CurPos.y;
	if (is_down) {
	 	n += (LineCount + 1);
		if (n>=MaxDispLine) n = MaxDispLine - ((CsvRecForm->Visible || isBinary)? 2: 1);
	}
	else {
		n -= (LineCount + 1);
		if (n<0) n = 0;
	}

	if (CurPos.y!=n) {
		IniSelected(sel);
		CurPos.y = n;
		adjust_PosX();
		if (sel) set_SelEnd();

		CurTop = CurPos.y - r;
		if (CurTop<1) CurTop = 1;
		CurTop = std::min(CurTop, ScrBar->Max - ScrBar->LargeChange - 1);
		CurBottom = CurTop + LineCount;

		Repaint(true);
		ScrBar->Position = CurTop;
	}
	else if (isBinary && !sel) {
		if (is_down) {
			if (isContinue) CursorDown();
		}
		else {
			if (TopAddress>0) CursorUp();
		}
	}
}

//---------------------------------------------------------------------------
//XN[̕\
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::ScrollAdjust()
{
	CurTop	  = ScrBar->Position;
	CurBottom = CurTop + LineCount;
	//J[\ɉ̈
	if (TvCursorVisible) {
		if (CurPos.y < CurTop-1) CurPos.y = CurTop -1;
		else if (CurPos.y > CurBottom-1) CurPos.y = CurBottom - 1;
	}
	SetSttInf();
	Repaint();
}

//---------------------------------------------------------------------------
//XN[
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::MoveScroll(
	bool is_down,		//
	UnicodeString prm,	//p[^
	bool move_csr)		//J[\ړ (default = false)
{
	if (is_down && CurBottom>=MaxDispLine) return;
	if (!is_down && CurTop<=1) return;

	int last_top = CurTop;

	if (prm.IsEmpty()) prm = "MW";
	int n = get_MovePrm(prm);
	CurTop += is_down? n : -n;

	if (is_down && CurTop>MaxDispLine)	CurTop = MaxDispLine;
	if (!is_down && CurTop<0)			CurTop = 0;

	if (move_csr) {
		if (is_down) {
			CurPos.y += (CurTop - last_top);
			if (CurPos.y > CurBottom-1) CurPos.y = CurBottom - 1;
		}
		else {
			CurPos.y -= (last_top - CurTop);
			if (CurPos.y<CurTop) CurPos.y = CurTop;
		}
	}

	CurBottom = CurTop + LineCount;
	ScrBar->Position = CurTop;
	Repaint(true);
}

//---------------------------------------------------------------------------
//sɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::LineTop(bool sel)
{
	IniSelected(sel);
	CurPos.x = CurHchX = 0;
	if (sel) set_SelEnd();
	UpdatePos();
}

//---------------------------------------------------------------------------
//sɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::MoveLineTop(
	bool is_next,	//true = / false = O
	bool sel)
{
	IniSelected(sel);
	int lno = get_CurLineNo() + (is_next? 1 : -1);
	for (int i=CurPos.y; i>=0 && i<MaxDispLine; i += (is_next? 1 : -1)) {
		line_rec *lp = get_LineRec(i);
		if ((is_next && lp->LineNo<lno) || (!is_next && (lp->LineIdx>0 || lp->LineNo>lno))) continue;
		CurPos  = Point(0, i);
		CurHchX = cv_PosX_to_HchX(CurPos.x);
		if (isSelMode) SelEnd = CurPos;
		UpdatePos(true);
		break;
	}
}

//---------------------------------------------------------------------------
//sɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::LineEnd(bool sel)
{
	IniSelected(sel);
	CurPos.x = get_CurEndPos();
	CurHchX  = cv_PosX_to_HchX(CurPos.x);
	if (sel) set_SelEnd();
	UpdatePos();
}

//---------------------------------------------------------------------------
//擪Ɉړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::TextTop(bool sel)
{
	if (isBinary && !sel && TopAddress!=0)
		AssignBin(0, true, 0);
	else {
		IniSelected(sel);
		CurPos.y = 0;
		CurPos.x = CurHchX = 0;
		if (sel) set_SelEnd();
		ScrBar->Position = 1;
		UpdatePos();
	}

	if (BitmapForm->Visible) BitmapForm->MapScrBox->VertScrollBar->Position = 0;
}
//---------------------------------------------------------------------------
//ŌɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::TextEnd(bool sel)
{
	if (isBinary && isContinue) {
		IniSelected();
		ToAddrA(BinFileSize - 1);
	}
	else {
		IniSelected(sel);
		CurPos.y = MaxDispLine - (CsvRecForm->Visible? 2 : 1);
		CurPos.x = CsvRecForm->Visible? 0 : get_CurEndPos();
		CurHchX  = cv_PosX_to_HchX(CurPos.x);
		if (sel) set_SelEnd();
		UpdatePos(true);
	}

	if (BitmapForm->Visible)
		BitmapForm->MapScrBox->VertScrollBar->Position = BitmapForm->MapScrBox->VertScrollBar->Range;
}

//---------------------------------------------------------------------------
//Nbv{[hɃRs[
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::ClipCopy(
	bool append)	//true = ǉRs[ (default = false)
{
	if (SelStart==SelEnd) return;

	UnicodeString sel_str;

	if (isBinary && !isBoxMode) {
		std::unique_ptr<TStringList> sel_lst(new TStringList());
		GetDumpList(sel_lst.get());
		sel_str = sel_lst->Text;
	}
	else
		sel_str = get_SelText(true);

	if (!sel_str.IsEmpty()) {
		if (append) sel_str.Insert(Clipboard()->AsText, 1);	//ǉ
		copy_to_Clipboard(sel_str);
		IniSelected();
		SetSttInf();
		Repaint(true);
	}
}

//---------------------------------------------------------------------------
//̒PɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::WordRight(bool sel)
{
	if (isBinary) {
		CursorRight(sel); CursorRight(sel);
	}
	else {
		IniSelected(sel);

		UnicodeString lbuf = get_CurLine();
		if (!has_CR(lbuf)) lbuf += get_DispLine(CurPos.y + 1);

		TMatchCollection mts = TRegEx::Matches(lbuf, WORD_MATCH_PTN);
		bool found = false;
		for (int i=0; i<mts.Count && !found; i++) {
			int idx = mts.Item[i].Index - 1;
			if (idx>CurPos.x) {
				CurPos.x = idx;
				CurPos	 = nrm_Pos(CurPos);
				found	 = true;
			}
		}
		if (!found) {
			if (CurPos.x < get_CurEndPos())
				CurPos.x = get_CurEndPos();
			else if (CurPos.y < MaxDispLine-1) {
				CurPos.y++; CurPos.x = 0;
			}
		}
		CurHchX = cv_PosX_to_HchX(CurPos.x);

		if (sel) set_SelEnd();
		UpdatePos();
	}
}

//---------------------------------------------------------------------------
//O̒PɈړ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::WordLeft(bool sel)
{
	if (isBinary) {
		CursorLeft(sel); CursorLeft(sel);
	}
	else {
		IniSelected(sel);

		UnicodeString lbuf = get_CurLine().SubString(1, CurPos.x);
		int ofs = 0;
		if (CurPos.y>0) {
			UnicodeString sbuf = get_DispLine(CurPos.y - 1);
			if (!has_CR(sbuf)) {
				lbuf = sbuf + lbuf;
				ofs += sbuf.Length();
			}
		}
		bool found = false;
		if (!lbuf.IsEmpty()) {
			TMatchCollection mts = TRegEx::Matches(lbuf, WORD_MATCH_PTN);
			if (mts.Count>0) {
				CurPos.x = mts.Item[mts.Count - 1].Index - 1 - ofs;
				CurPos	 = nrm_Pos(CurPos);
				found	 = true;
			}
		}
		if (!found) {
			if (CurPos.y>0) {
				CurPos.y--;
				CurPos.x = get_CurEndPos();
			}
			else
				CurPos.x = 0;
		}
		CurHchX = cv_PosX_to_HchX(CurPos.x);

		if (sel) set_SelEnd();
		UpdatePos();
	}
}

//---------------------------------------------------------------------------
//I𕶎擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::get_SelText(
	bool clr_sel)	//擾AIԂNA (default = false)
{
	if (SelStart==SelEnd) return EmptyStr;

	UnicodeString sel_str;
	//Ps
	if (SelStart.y==SelEnd.y) {
		TPoint sp0 = SelStart;
		TPoint sp1 = SelEnd;
		if (sp0.x>sp1.x) std::swap(sp0, sp1);
		sel_str = get_DispLine(sp0.y).SubString(sp0.x + 1, sp1.x - sp0.x);
	}
	//s
	else {
		//`I
		if (isBoxMode) {
			TPoint sp0 = BoxStart;
			TPoint sp1 = BoxEnd;
			bool flag = (sp0.y==sp1.y)? (sp0.x>sp1.x) : (sp0.y>sp1.y);
			if (flag) std::swap(sp0, sp1);
			if (sp0.x>sp1.x) std::swap(sp0.x, sp1.x);
			int wp0 = sp0.x * HchWidth;
			int wp1 = sp1.x * HchWidth;
			for (int i=sp0.y; i<=sp1.y && i<MaxDispLine; i++) {
				UnicodeString lbuf = get_DispLine(i);
				if (get_LineRec(i)->LineIdx>0) continue;
				UnicodeString sbuf;
				int w = 0;
				for (int j=1; j<=lbuf.Length(); j++) {
					WideChar c = lbuf[j];
					w = add_CharWidth(c, w);
					if (w>wp1) break;
					if (w>wp0) sbuf.cat_sprintf(_T("%c"), c);
				}
				if (!has_CR(sbuf)) sbuf.UCAT_T("\r\n");
				sel_str += sbuf;
			}
		}
		//ʏI
		else {
			TPoint sp0 = SelStart;
			TPoint sp1 = SelEnd;
			bool flag = (sp0.y==sp1.y)? (sp0.x>sp1.x) : (sp0.y>sp1.y);
			if (flag) std::swap(sp0, sp1);
			for (int i=sp0.y; i<=sp1.y && i<MaxDispLine; i++) {
				UnicodeString lbuf = get_DispLine(i);
				if (i==sp0.y) {
					if (sp0.x>0) lbuf.Delete(1, sp0.x);
				}
				if (i==sp1.y) {
					if (sp1.x<lbuf.Length()) lbuf = lbuf.SubString(1, sp1.x);
				}
				sel_str += REPLACE_TS(lbuf, "\n", "\r\n");
				if (isBinary) sel_str.UCAT_T("\r\n");
			}
		}
	}

	if (clr_sel) {
		IniSelected();
		SetSttInf();
	}

	return sel_str;
}

//---------------------------------------------------------------------------
//J[\ʒu̕擾
//---------------------------------------------------------------------------
WideChar __fastcall TTxtViewer::get_CurChar()
{
	WideChar chstr = '\0';
	UnicodeString lnstr = get_DispLine(CurPos.y);
	if (CurPos.x<lnstr.Length()) chstr = lnstr[CurPos.x + 1];
	return chstr;
}

//---------------------------------------------------------------------------
//J[\s̕擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::get_CurLine(
	bool to_cr)		//s܂Ŏ擾 (default = false)
{
	UnicodeString lnstr;
	if (isBinary || !to_cr)
		lnstr = get_DispLine(CurPos.y);
	else {
		for (int i=CurPos.y; i<MaxDispLine; i++) {
			lnstr += get_DispLine(i);
			if (has_CR(lnstr)) break;
		}
	}
	return lnstr;
}
//---------------------------------------------------------------------------
//J[\s̍sԍ擾
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::get_CurLineNo()
{
	if (!isReady) return 0;

	int idx = std::min<int>(CurPos.y, MaxDispLine - 1);
	if (idx>=0) {
		line_rec *lp = get_LineRec(idx);
		return (lp->LineNo!=-1)? lp->LineNo : MaxLine;
	}
	else return 1;
}

//---------------------------------------------------------------------------
//J[\ʒu̐΃AhX擾 (oCi)
//---------------------------------------------------------------------------
__int64 __fastcall TTxtViewer::get_CurAddrA()
{
	return TopAddress + get_CurAddrR();
}
//---------------------------------------------------------------------------
//J[\ʒȗ΃AhX擾 (oCi)
//---------------------------------------------------------------------------
unsigned int __fastcall TTxtViewer::get_CurAddrR()
{
	return std::min<unsigned int>(CurPos.y*16 + get_OfsR(CurPos.x), BinarySize - 1);
}
//---------------------------------------------------------------------------
//s̃ItZbg擾 (oCi)
//---------------------------------------------------------------------------
unsigned int __fastcall TTxtViewer::get_OfsR(int xp)
{
	unsigned int p = xp;
	if (p>=50)
		p -= 50;
	else {
		if (p>=24) p--;
		p /= 3;
	}
	if (p>15) p = 15;
	return p;
}

//---------------------------------------------------------------------------
//J[\ʒu̍s(y)E(x)擾 (eLXg)
//---------------------------------------------------------------------------
TPoint __fastcall TTxtViewer::get_CurLinePos()
{
	if (CurPos.y < MaxDispLine-1) {
		int n = 1;
		int p = (CurPos.x>0)? str_len_unicode(get_DispLine(CurPos.y).SubString(1, CurPos.x)) + 1 : 1;
		for (int i=CurPos.y; i>=0; i--) {
			if (i!=CurPos.y) p += str_len_unicode(get_DispLine(i));
			line_rec *lp = get_LineRec(i);
			if (lp->LineIdx==0) { n = lp->LineNo;  break; }
		}
		return Point(p, n);
	}
	else
		return Point(1, MaxLine);
}

//---------------------------------------------------------------------------
//SđI
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SelectAll()
{
	if (MaxDispLine>0) {
		unsigned int idx = MaxDispLine - 1;
		unsigned int pos = get_DispLine(idx).Length();
		SelEnd	  = Point(pos, idx);
		SelStart  = Point(0, 0);
		isBoxMode = false;
		Repaint();
	}
}

//---------------------------------------------------------------------------
//J[\ʒu̒P擾/I
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::GetCurWord(
	bool select,			//I				(default = false)
	UnicodeString ptn,		//}b`p^[	(default = EmptyStr)
	int *xp)				//ʒu				(default = NULL)
{
	if (select) IniSelected();

	UnicodeString lbuf = get_CurLine(true);
	line_rec *lp = get_LineRec(CurPos.y);
	int ofs = 0;
	if (lp->LineIdx>0 && CurPos.y>0) {
		UnicodeString pbuf = get_DispLine(CurPos.y - 1);
		lbuf = pbuf + lbuf;
		ofs  = pbuf.Length();
	}

	UnicodeString ret_str;
	if (!lbuf.IsEmpty()) {
		TMatchCollection  mts;
		if (!ptn.IsEmpty())
			mts = TRegEx::Matches(lbuf, ptn);
		else {
			mts = TRegEx::Matches(lbuf, LINK_MATCH_PTN);
			if (mts.Count==0) mts = TRegEx::Matches(lbuf, WORD_MATCH_PTN);
		}

		for (int i=0; i<mts.Count; i++) {
			int p0 = mts.Item[i].Index - 1 - ofs;
			int p1 = p0 + mts.Item[i].Length;
			if (p0<=CurPos.x && CurPos.x<p1) {
				ret_str = mts.Item[i].Value;
				if (xp) *xp = p1;
				if (select) {
					SelStart = nrm_Pos(Point(p0, CurPos.y));
					SelEnd	 = nrm_Pos(Point(p1, CurPos.y));
					CurPos   = SelEnd;
					CurHchX	 = cv_PosX_to_HchX(CurPos.x);
					Repaint(true);
				}
				break;
			}
		}
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//sPʂōsŜI
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::SelLine(bool cr)
{
	inh_Repaint = true;
	LineTop();
	if (cr) {
		while (CurPos.y > 0) {
			if (get_LineRec(CurPos.y)->LineIdx==0) break;
			CursorUp();
		}
	}
	LineEnd(true);
	if (cr) {
		while (CurPos.y < MaxDispLine-1) {
			if (get_LineRec(CurPos.y)->hasCR) break;
			CursorDown(true);
		}
	}
	inh_Repaint = false;
	Repaint();
}

//---------------------------------------------------------------------------
//R[hy[W̕ύX
// ߂l : 0 = sȎw
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::change_CodePage(UnicodeString prm)
{
	std::unique_ptr<TStringList> cp_lst(new TStringList());
	cp_lst->Text =
		"932\n"		//Shift_JIS
		"50220\n"	//JIS(ISO-2022-JP)
		"20932\n"	//EUC-JP
		"1252\n"	//Latin-1
		"65001\n"	//UTF-8
		"1200\n";	//UTF-16

	int code_page;
	if (!prm.IsEmpty()) {
		code_page = (cp_lst->IndexOf(prm)==-1)? 0 : prm.ToIntDef(932);
	}
	//wȂ玟̃R[hy[Wɐ؂ւ
	else {
		int pn = cp_lst->IndexOf(IntToStr((int)TxtBufList->Encoding->CodePage));
		code_page = (pn!=-1)? cp_lst->Strings[(pn + 1)%cp_lst->Count].ToIntDef(932) : 932;
	}

	return code_page;
}

//---------------------------------------------------------------------------
//J[\ʒủ摜t@C擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TTxtViewer::GetCurImgFile()
{
	UnicodeString fnam = GetCurWord(false, "[^\"(=*?<>|i ]+\\.\\w+\\b");
	remove_top_text(fnam, _T("file:///"));
	fnam = slash_to_yen(fnam);
	fnam = to_absolute_name(fnam, ExtractFilePath(FileName));
	UnicodeString fext = get_extension(fnam);
	if (test_FileExt(fext, get_img_fext())) return fnam;
	return EmptyStr;
}

//---------------------------------------------------------------------------
//p[^ړs擾
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::get_MovePrm(UnicodeString prm)
{
	int n = 1;
	if (!prm.IsEmpty()) {
		switch (idx_of_word_i(_T("HP|FP|MW"), prm)) {
		case  0: n = (LineCount + 1)/2;	break;
		case  1: n = LineCount + 1;		break;
		case  2: n = ViewWheelScrLn;	break;
		default: n = prm.ToIntDef(1);
		}
	}
	return n;
}

//---------------------------------------------------------------------------
//oCg(Xy[X؂216i)ɕϊ
// ߂l : oCg
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::to_Bytes(
	UnicodeString s,
	bool &case_sw,		//pň͂܂ꂽ̑召
	int code_page)
{
	int len = s.Length();
	if (len==0) return 0;

	//
	if (is_quot(s)) {
		s = exclude_quot(s);
		std::unique_ptr<TEncoding> enc(TEncoding::GetEncoding(code_page));
		if (!case_sw) {
			FindByte0 = enc->GetBytes(s.UpperCase());
			FindByte1 = enc->GetBytes(s.LowerCase());
		}
		else
			FindByte0 = enc->GetBytes(s);

		FindMask.Length = FindByte0.Length;
		for (int i=0; i<FindMask.Length; i++) FindMask[i] = 0xff;
	}
	//l
	else {
		case_sw = true;
		TStringDynArray b_lst = SplitString(Trim(s), " ");
		FindByte0.Length = b_lst.Length;
		FindMask.Length  = b_lst.Length;
		try {
			for (int i=0; i<b_lst.Length; i++) {
				UnicodeString s = b_lst[i];
				//HEX
				if (s.Length()==2) {
					//ChJ[h ? }XNݒ
					BYTE m = 0xff;
					if (s[1]=='?') m &= 0x0f;
					if (s[2]=='?') m &= 0xf0;
					FindMask[i] = m;
					s = REPLACE_TS(s, "?", "0");
					//lݒ
					FindByte0[i] = ("0x" + s).ToInt();
				}
				//BIT
				else if (s.Length()==8) {
					BYTE b = 0;
					BYTE m = 0;
					for (int i=1; i<=8; i++) {
						b <<= 1;  m <<= 1;
						if      (s[i]=='1') { b |= 0x01;  m |= 0x01; }
						else if (s[i]=='0') m |= 0x01;
						else if (s[i]!='?') Abort();
					}
					FindByte0[i] = b;
					FindMask[i]  = m;
				}
				else Abort();
			}
		}
		catch (...) {
			FindByte0.Length = 0;
			beep_Warn();
		}
	}
	return FindByte0.Length;
}

//---------------------------------------------------------------------------
//񌟍
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchCore(
	bool is_down,		//
	UnicodeString kwd,	//
	bool case_sw,		//召
	bool reg_sw,		//K\
	bool bytes_sw,		//oCg񌟍
	bool from_pos)		//݈ʒu猟	(default = false)
{
	LastFound = false;

	if (!kwd.IsEmpty() && (!reg_sw || chk_RegExPtn(kwd))) {
		//oCg񌟍
		if (isBinary && bytes_sw) {
			LastFound = is_down? SearchDownBytes(kwd, case_sw, reg_sw) : SearchUpBytes(kwd, case_sw, reg_sw);

			//qbgsXg̍XV
			if (ScrPanel->KeyWordChanged(kwd, MaxDispLine, case_sw, BinCodePage)
				&& to_Bytes(kwd, case_sw, BinCodePage)>0)
			{
				cursor_HourGlass();
				unsigned int adr = 0;
				int p = 0;
				while (adr<BinarySize) {
					if (case_sw? ((MMF->Bytes[adr] & FindMask[p])==(FindByte0[p] & FindMask[p])) :
								 (MMF->Bytes[adr]==FindByte0[p] || MMF->Bytes[adr]==FindByte1[p]))
					{
						p++;
						if (p>=FindByte0.Length) {
							int idx = (adr - p + 1)/16;
							ScrPanel->AddHitLine(idx);
							p = 0;
							adr = (idx + 1) * 16;
						}
						else adr++;
					}
					else {
						p = 0;
						adr++;
					}
				}
				ScrPanel->Repaint();
				cursor_Default();
			}
		}
		//񌟍
		else {
			cursor_HourGlass();
			TRegExOptions opt;
			if (!case_sw) opt << roIgnoreCase;
			for (int i=CurPos.y; i>=0 && i<MaxDispLine; i += (is_down? 1 : -1)) {
				UnicodeString lbuf, sbuf;
				int p = 0, ofs = 0;
				if (is_down) {
					lbuf = get_DispLine(i);
					if (isText) {
						for (int i2=i+1; i2<MaxDispLine; i2++) {
							if (has_CR(lbuf) || get_LineRec(i2)->LineIdx==0) break;
							lbuf += get_DispLine(i2);
						}
					}

					p = (i==CurPos.y)? CurPos.x + (from_pos? 1 : 2) : 1;
					sbuf = lbuf.SubString(p, lbuf.Length() - p + 1);
				}
				else {
					if (isText && i>1) {
						lbuf = get_DispLine(i - 1);
						if (has_CR(lbuf)) lbuf = EmptyStr;
						ofs += lbuf.Length();
					}
					lbuf += get_DispLine(i);
					if (i==CurPos.y) lbuf = lbuf.SubString(1, CurPos.x + ofs);
				}

				int match_p;
				int match_len;
				if (reg_sw) {
					if (is_down) {
						if (StartsStr('^', kwd) && p>1)
							match_p = 0;
						else {
							TMatch mt = TRegEx::Match(sbuf, kwd, opt);
							if (mt.Success) {
								match_p   = mt.Index;
								match_len = mt.Length;
							}
							else
								match_p = 0;
						}
					}
					else {
						TMatchCollection mts = TRegEx::Matches(lbuf, kwd, opt);
						if (mts.Count>0) {
							match_p   = mts.Item[mts.Count - 1].Index;
							match_len = mts.Item[mts.Count - 1].Length;
						}
						else
							match_p = 0;
					}
				}
				else {
					match_p = is_down? (case_sw? sbuf.Pos(kwd) : pos_i(kwd, sbuf)) :
									   (case_sw? pos_r(kwd, lbuf) : pos_r_i(kwd, lbuf));
					match_len = kwd.Length();
				}

				if (match_p>0) {
					match_p  += is_down? (p - 1) : -ofs;
					LastFound = true;
					isSelMode = isBoxMode = false;
					CurPos	  = nrm_Pos(Point(match_p - 1, i));
					CurHchX   = cv_PosX_to_HchX(CurPos.x);
					SelStart  = CurPos;
					SelEnd	  = nrm_Pos(Point(CurPos.x + match_len, CurPos.y));
					UpdatePos(true);
					break;
				}
			}
			cursor_Default();

			//qbgsXg̍XV
			if (ScrPanel->KeyWordChanged(kwd, MaxDispLine, case_sw)) {
				cursor_HourGlass();
				TRegExOptions opt;
				if (!case_sw) opt << roIgnoreCase;
				for (int i=0; i<MaxDispLine; i++) {
					UnicodeString lbuf = get_DispLine(i);
					if (reg_sw? TRegEx::IsMatch(lbuf, kwd, opt) : case_sw? lbuf.Pos(kwd) : pos_i(kwd, lbuf)) {
						ScrPanel->AddHitLine(i);
					}
				}
				ScrPanel->Repaint();
				cursor_Default();
			}
		}
	}
	else {
		ScrPanel->KeyWordChanged(EmptyStr, 0);
	}

	if (!LastFound && !XCMD_IsBusy && !isIncSea) beep_Warn();

	return LastFound;
}

//---------------------------------------------------------------------------
//ɕ񌟍
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchDown(
	UnicodeString kwd,	//
	bool case_sw,		//召	(default = false)
	bool reg_sw,		//K\			(default = false)
	bool bytes_sw,		//oCg񌟍		(default = false)
	bool from_pos)		//݈ʒu猟	(default = false)
{
	return SearchCore(true, kwd, case_sw, reg_sw, bytes_sw, from_pos);
}
//---------------------------------------------------------------------------
//ɕ񌟍
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchUp(UnicodeString kwd, bool case_sw, bool reg_sw, bool bytes_sw)
{
	return SearchCore(false, kwd, case_sw, reg_sw, bytes_sw);
}

//---------------------------------------------------------------------------
//ɃoCg񌟍
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchDownBytes(UnicodeString kwd, bool case_sw, bool reg_sw)
{
	if (to_Bytes(kwd, case_sw, BinCodePage)==0) return false;

	cursor_HourGlass();
	bool found = false;
	unsigned int adr = get_CurAddrR() + 1;
	int p = 0;
	while (adr<BinarySize) {
		if (case_sw? ((MMF->Bytes[adr] & FindMask[p])==(FindByte0[p] & FindMask[p])) :
					 (MMF->Bytes[adr]==FindByte0[p] || MMF->Bytes[adr]==FindByte1[p]))
		{
			p++;
			if (p>=FindByte0.Length) {
				adr -= (FindByte0.Length - 1);
				found = ToAddrR(adr);
				break;
			}
		}
		else p = 0;
		adr++;
	}
	cursor_Default();
	return found;
}

//---------------------------------------------------------------------------
//ɃoCg񌟍
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchUpBytes(UnicodeString kwd, bool case_sw, bool reg_sw)
{
	if (to_Bytes(kwd, case_sw, BinCodePage)==0) return false;
	unsigned int adr = get_CurAddrR();	if (adr==0) return false;

	cursor_HourGlass();
	bool found = false;
	if (FindByte0.Length==1) adr--;
	int p = FindByte0.Length - 1;
	for (;;) {
		if (case_sw? ((MMF->Bytes[adr] & FindMask[p]) == (FindByte0[p] & FindMask[p])) :
					 (MMF->Bytes[adr]==FindByte0[p] || MMF->Bytes[adr]==FindByte1[p]))
		{
			if (p==0) { found = ToAddrR(adr);  break; }
			p--;
		}
		else p = FindByte0.Length - 1;
		if (adr==0) break;
		adr--;
	}
	cursor_Default();
	return found;
}

//---------------------------------------------------------------------------
//I𕶎
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchSel(
	bool up_sw,		//true = / false = 
	bool em_sw)		//true = }b`\
{
	UnicodeString s = get_SelText();
	if (!s.IsEmpty()) LastSelWord = s; else s = LastSelWord;

	if (em_sw) {
		RegExPtn  = TRegEx::Escape(s);
		FindWord  = s;
		Highlight = true;
		Repaint(true);
	}

	return (up_sw? SearchUp(s, false) : SearchDown(s, false));
}

//---------------------------------------------------------------------------
//Ή銇ʂ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::SearchPair()
{
	UnicodeString br_str = "ikmoqsuwy({[";
	UnicodeString kt_str = "jlnprtvxz)}]";

	WideChar bk_ch = get_CurChar();
	int p_b = br_str.Pos(bk_ch);
	int p_k = kt_str.Pos(bk_ch);

	bool found = false;
	//ʊJ  ʕ
	if (p_b>0) {
		WideChar b_ch = bk_ch;
		WideChar k_ch = kt_str[p_b];
		int lvl = 0;
		for (int i=CurPos.y; !found && i<MaxDispLine; i++) {
			UnicodeString lbuf = get_DispLine(i);
			int p = (i==CurPos.y)? CurPos.x + 2 : 1;
			for (int j=p; !found && j<lbuf.Length(); j++) {
				if (lbuf[j]==k_ch) {
					if (lvl==0) {
						CurPos = Point(j - 1, i);
						found  = true;
					}
					else lvl--;
				}
				else if (lbuf[j]==b_ch) lvl++;
			}
		}
	}
	//ʕ  ʊJ
	else if (p_k>0) {
		WideChar b_ch = br_str[p_k];
		WideChar k_ch = bk_ch;
		int lvl = 0;
		for (int i=CurPos.y; !found && i>=0; i--) {
			UnicodeString lbuf = get_DispLine(i);
			int p = (i==CurPos.y)? CurPos.x : lbuf.Length();
			for (int j=p; !found && j>0; j--) {
				if (lbuf[j]==b_ch) {
					if (lvl==0) {
						CurPos = Point(j - 1, i);
						found = true;
					}
					else lvl--;
				}
				else if (lbuf[j]==k_ch) lvl++;
			}
		}
	}

	if (found) {
		CurHchX = cv_PosX_to_HchX(CurPos.x);
		if (isSelMode) SelEnd = CurPos;
		if (CurPos.y<CurTop || CurPos.y>=CurBottom-1)
			UpdatePos(true);
		else {
			Repaint();
			SetSttInf();
		}
	}

	return found;
}

//---------------------------------------------------------------------------
//wsԍɈړ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::ToLine(
	int lno, 	//sԍ
	int col)	//ԍ(Œ蒷\)
{
	if (lno<=0) return false;

	bool jumped = false;
	for (int i=0; i<MaxDispLine && !jumped; i++) {
		line_rec *lp = get_LineRec(i);
		if (lp->LineIdx>0 || lno!=lp->LineNo) continue;
		CurPos  = Point(0, i);
		CurHchX = cv_PosX_to_HchX(CurPos.x);
		if (isSelMode) SelEnd = CurPos;
		UpdatePos(true);
		if (col!=-1) set_PosFromCol(col);
		jumped = true;
	}

	return jumped;
}
//---------------------------------------------------------------------------
//TopAddress ̑΃AhXɈړ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::ToAddrR(unsigned int adr)
{
	if (!isBinary) return false;

	bool found = false;
	int idx = adr/16;
	if (adr<BinarySize && idx<MaxDispLine) {
		int x = (adr%16) * 3;	if (x>21) x++;
		CurPos	= Point(x, idx);
		CurHchX = cv_PosX_to_HchX(CurPos.x);
		UpdatePos(true);
		SetSttInf();
		found = true;
	}
	else if (BinarySize==0 && adr==0) {
		TextTop();
		found = true;
	}
	return found;
}
//---------------------------------------------------------------------------
//΃AhXɈړ
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::ToAddrA(__int64 adr)
{
	bool found = false;
	__int64 adr_r = adr - TopAddress;
	if (adr_r>=0 && adr_r<BinarySize)
		found = ToAddrR(adr_r);
	else if (adr<BinFileSize) {
		int ofs = adr%ViewBinLimitSize;
		adr -= ofs;
		found = AssignBin(adr, true, ofs);
	}
	return found;
}

//---------------------------------------------------------------------------
void __fastcall TTxtViewer::JumpLine(UnicodeString ln_str)
{
	try {
		bool jumped = false;
		UnicodeString msg;
		//oCi
		if (isBinary) {
			if (ln_str.IsEmpty()) {
				InputExDlg->IpuntExMode = INPEX_JUMP_ADDR;
				InputExDlg->InputEdit->EditLabel->Caption
					= UnicodeString().sprintf(_T("0`%s (%llu)"), get_AddrStr(BinFileSize - 1).c_str(), BinFileSize - 1);
				ln_str = (InputExDlg->ShowModal()==mrOk)? InputExDlg->InputEdit->Text : EmptyStr;
			}

			remove_text(ln_str, _T(":"));
			if (ln_str.IsEmpty()) throw EAbort(EmptyStr);	//LZ

			bool is_rel = starts_tchs(_T("+-"), ln_str);	//Ύw肩?
			int rel_sig = 0;
			if (is_rel) {
				rel_sig = (ln_str[1]=='-')? -1 : 1;
				ln_str.Delete(1, 1);
			}
			__int64 inp_adr = StrToInt64Def(ln_str, -1);
			if (inp_adr==-1) UserAbort(USTR_IllegalAddress);
			if (is_rel) inp_adr = get_CurAddrA() + rel_sig * inp_adr;
			jumped = ToAddrA(inp_adr);
		}
		//eLXg
		else {
			InputExDlg->IpuntExMode = INPEX_JUMP_LINE;
			InputExDlg->InputEdit->EditLabel->Caption = msg.sprintf(_T("sԍ(1`%u)"), MaxLine);
			ln_str = (InputExDlg->ShowModal()==mrOk)? InputExDlg->InputEdit->Text : EmptyStr;
			if (ln_str.IsEmpty()) throw EAbort(EmptyStr);	//LZ
			if (contains_wd_i(ln_str, _T("+|="))) throw EAbort(EmptyStr);

			int inp_n = ln_str.ToIntDef(-1);
			if (inp_n==-1)				   UserAbort(USTR_IllegalParam);
			if (inp_n<=0 || inp_n>MaxLine) SysErrAbort(DISP_E_OVERFLOW);

			for (int i=0; i<MaxDispLine && !jumped; i++) {
				if (!SameText(ln_str, UnicodeString(get_LineRec(i)->LineNo))) continue;
				CurPos	= Point(0, i);
				CurHchX = cv_PosX_to_HchX(CurPos.x);
				if (isSelMode) SelEnd = CurPos;
				UpdatePos(true);
				jumped = true;
			}
		}

		if (!jumped) throw EAbort(LoadUsrMsg(USTR_NotFound, _T("ړ")));
	}
	catch (EAbort &e) {
		GlobalErrMsg = e.Message;
	}
}

//---------------------------------------------------------------------------
//}[N (gO)
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::MarkLine(int lno)
{
	//ݒ
	if (!IsMarked(lno))
		MarkListStr.cat_sprintf(_T("%u;"), lno);
	//
	else if (!MarkListStr.IsEmpty()) {
		UnicodeString s0, s1;
		MarkListStr = ReplaceStr(s0.sprintf(_T(";%s"), MarkListStr.c_str()), s1.sprintf(_T(";%u;"), lno), ";");
		remove_top_s(MarkListStr, ';');
	}
	Repaint(true);
}
//---------------------------------------------------------------------------
//}[NĂ邩H
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::IsMarked(
	int lno)	//sԍ (default = 0: ݍs)
{
	if (!isReady) return false;

	if (lno==0) lno = get_CurLineNo();
	UnicodeString s0, s1;
	return ContainsText(s0.sprintf(_T(";%s"), MarkListStr.c_str()), s1.sprintf(_T(";%u;"), lno));
}

//---------------------------------------------------------------------------
//{ɒǉ
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::add_ViewHistory()
{
	if (FileName.IsEmpty() || ContainsText(FileName, TempPathA)) return;
	if (match_path_list(FileName, NoViewHistPath)) return;

	for (;;) {
		int idx = indexof_csv_list(TextViewHistory, FileName, 0);
		if (idx!=-1) TextViewHistory->Delete(idx); else break;
	}

	UnicodeString lbuf;
	lbuf.sprintf(_T("%s,%u,"), add_quot_if_spc(FileName).c_str(), get_CurLineNo());
	lbuf += MarkListStr;
	TextViewHistory->Insert(0, lbuf);
}

//---------------------------------------------------------------------------
//_vXg擾
//I𒆂Ȃ炻͈̔́AłȂꍇS
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::GetDumpList(TStringList *lst)
{
	cursor_HourGlass();

	TPoint sp0, sp1;
	int ofs0, ofs1;
	//I͈
	if (SelStart!=SelEnd) {
		sp0 = SelStart;
		sp1 = SelEnd;
		bool flag = (sp0.y==sp1.y)? (sp0.x>sp1.x) : (sp0.y>sp1.y);
		if (flag) std::swap(sp0, sp1);
		if (sp1.x==0) { sp1.y--;  sp1.x = 48; }
		ofs0 = get_OfsR(sp0.x);
		ofs1 = (sp1.x<48 || (sp1.x>=50 && sp1.x<66))? get_OfsR(sp1.x) - 1 : 15;
	}
	//S
	else {
		sp0 = Point(0, 0);
		sp1 = Point(48, MaxDispLine - 1);
		ofs0 = 0;
		ofs1 = 15;
	}

	int adr_len  = get_AddrStr(TopAddress + sp1.y*16).Length();
	UnicodeString hdstr;
	hdstr.sprintf(_T("%-*s"), adr_len + 2, _T("ADDRESS"));
	hdstr.UCAT_T("+0 +1 +2 +3 +4 +5 +6 +7  +8 +9 +A +B +C +D +E +F  0123456789ABCDEF");
	lst->Add(hdstr);
	lst->Add(StringOfChar(_T('-'), adr_len + 68));

	for (int i=sp0.y; i<=sp1.y; i++) {
		UnicodeString lbuf = get_DispLine(i, (i==sp0.y)? ofs0 : 0,  (i==sp1.y)? ofs1 : 15);
		if (lbuf.IsEmpty()) break;
		lbuf.Insert(get_AddrStr(TopAddress + i*16, adr_len).UCAT_T("  "), 1);
		lst->Add(lbuf);
	}
	cursor_Default();
}

//---------------------------------------------------------------------------
//CN^T[`
//---------------------------------------------------------------------------
void __fastcall TTxtViewer::IncSearch(UnicodeString keystr)
{
	UnicodeString CmdStr = KeyFuncList->Values["S:" + keystr];
	bool chg_wd = false;

	//T[`[h甲
	if (USAME_TI(CmdStr, "IncSearchExit") || equal_ESC(keystr)) {
		isIncSea = false;
	}
	//L[[hNA
	else if (USAME_TI(CmdStr, "ClearIncKeyword")) {
		IncSeaWord = EmptyStr;
		chg_wd = true;
	}
	//Migemo[hؑ
	else if (USAME_TI(CmdStr, "MigemoMode")) {
		isIncMigemo = (!isIncMigemo && usr_Migemo->DictReady);
		IncSeaWord	= EmptyStr;
		chg_wd = true;
	}
	else if (USAME_TI(CmdStr, "NormalMode")) {
		isIncMigemo = false;
		IncSeaWord	= EmptyStr;
		chg_wd = true;
	}
	//L[[hXV
	else chg_wd = update_IncSeaWord(IncSeaWord, keystr);

	RegExPtn = usr_Migemo->GetRegExPtn(isIncMigemo, IncSeaWord);

	if (isIncSea) {
		if (!RegExPtn.IsEmpty()) {
			bool csr_up   = (USAME_TI(CmdStr, "IncSearchUp")   || equal_UP(keystr));
			bool csr_down = (USAME_TI(CmdStr, "IncSearchDown") || equal_DOWN(keystr));

			// փT[`
			if (chg_wd || csr_down) {
				if (chg_wd) Repaint(true);
				if (!SearchDown((isIncMigemo? RegExPtn : IncSeaWord), IncSeaCaseSens, isIncMigemo, false, chg_wd)
					 && chg_wd && !isIncMigemo)
				{
					//ʏ탂[hŌȂꍇAxĈꕶ
					SttHeader->Tag = SHOW_WARN_TAG;
					SetSttInf();  SttHeader->Repaint();
					beep_Warn();  Sleep(250);
					SttHeader->Tag = 0;
					delete_end(IncSeaWord);
				}
			}
			//փT[`
			else if (csr_up)
				SearchUp(RegExPtn, IncSeaCaseSens, isIncMigemo);
		}
		else {
			IniSelected();
			Repaint(true);
		}
	}

	SetSttInf();
}

//---------------------------------------------------------------------------
//W̃L[
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::StdKeyOperation(UnicodeString keystr)
{
	switch (idx_of_word_i(
		_T("DOWN|UP|LEFT|RIGHT|PGDN|PGUP|HOME|END|")													//0`7
		_T("Shift+DOWN|Shift+UP|Shift+LEFT|Shift+RIGHT|Shift+PGDN|Shift+PGUP|Shift+HOME|Shift+END"),	//0`15
		keystr))
	{
	case  0: CursorDown();			break;
	case  1: CursorUp();			break;
	case  2: CursorLeft();			break;
	case  3: CursorRight();			break;
	case  4: MovePage(true);		break;
	case  5: MovePage(false);		break;
	case  6: TextTop();				break;
	case  7: TextEnd();				break;
	case  8: CursorDown(true);		break;
	case  9: CursorUp(true);		break;
	case 10: CursorLeft(true);		break;
	case 11: CursorRight(true);		break;
	case 12: MovePage(true,  true);	break;
	case 13: MovePage(false, true);	break;
	case 14: TextTop();				break;
	case 15: TextEnd(true);			break;
	default:						return false;
	}

	SetSttInf();
	return true;
}

//---------------------------------------------------------------------------
//ʃR}h̃CfbNX擾
//---------------------------------------------------------------------------
int __fastcall TTxtViewer::GetComCmdIndex(UnicodeString cmd)
{
	return idx_of_word_i(
		_T("CursorDown|CursorDownSel|CursorUp|CursorUpSel|PageDown|PageDownSel|PageUp|PageUpSel|CursorLeft|CursorLeftSel|")	  // 0` 9
		_T("CursorRight|CursorRightSel|LineTop|LineTopSel|LineEnd|LineEndSel|TextTop|TextTopSel|TextEnd|TextEndSel|")		  //10`19
		_T("WordLeft|WordRight|ScrollUp|ScrollDown|ScrollCursorUp|ScrollCursorDown|SearchPair|SelCurWord|SelLine|SelLineCR|") //20`29
		_T("SelectAll|JumpLine|SelectMode|FindSelDown|FindSelUp"), cmd);													  //30`34
}

//---------------------------------------------------------------------------
//R}hs
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::ExeCommand(const _TCHAR *t_cmd, UnicodeString prm)
{
	bool handled = true;
	GlobalErrMsg = EmptyStr;

	UnicodeString cmd = t_cmd;

	if (prm.IsEmpty()) {
		prm = exclude_quot(get_PrmStr(cmd));
		cmd = get_CmdStr(cmd);
	}
	prm = extract_ExeParam(prm);

	if (isExtWnd) {
		if (contained_wd_i(_T("BitmapView|CharInfo|CsvCalc|CsvGraph|CsvRecord|Inspector|ImgPreview"), cmd)) return false;
	}

	int cur_lno = get_CurLineNo();

	//-------------------------------
	//ʂ̃R}h
	//-------------------------------
	int idx = GetComCmdIndex(cmd);
	if (idx!=-1) {
		switch (idx) {
		case  0: CursorDown(isSelMode, prm);	break;
		case  1: CursorDown(true);				break;
		case  2: CursorUp(isSelMode, prm);		break;
		case  3: CursorUp(true);				break;
		case  4: MovePage(true,  isSelMode);	break;
		case  5: MovePage(true,  true);			break;
		case  6: MovePage(false, isSelMode);	break;
		case  7: MovePage(false, true);			break;
		case  8: CursorLeft(isSelMode);			break;
		case  9: CursorLeft(true);				break;
		case 10: CursorRight(isSelMode);		break;
		case 11: CursorRight(true);				break;
		case 12: LineTop(isSelMode);			break;
		case 13: LineTop(true);					break;
		case 14: LineEnd(isSelMode);			break;
		case 15: LineEnd(true);					break;
		case 16: TextTop(isSelMode);			break;
		case 17: TextTop(true);					break;
		case 18: TextEnd(isSelMode);			break;
		case 19: TextEnd(true);					break;
		case 20: WordLeft(isSelMode);			break;
		case 21: WordRight(isSelMode);			break;
		case 22: MoveScroll(false, prm);		break;
		case 23: MoveScroll(true,  prm);		break;
		case 24: MoveScroll(false, prm, true);	break;
		case 25: MoveScroll(true,  prm, true);	break;
		case 26: SearchPair();					break;
		case 27: GetCurWord(true);				break;
		case 28: SelLine();						break;
		case 29: SelLine(true);					break;
		case 30: SelectAll();					break;
		case 31: JumpLine(prm);					break;
		case 32: isSelMode = !isSelMode;		break;
		case 33: SearchSel(false, USAME_TI(prm, "EM"));	break;
		case 34: SearchSel(true,  USAME_TI(prm, "EM"));	break;
		}
	}
	//zF̐ݒ
	else if (USAME_TI(cmd, "SetColor")) {
		if (!prm.IsEmpty())
			SetColor(prm); 
		else {
			if (!ColorDlg) ColorDlg = new TColorDlg(Application->MainForm);	//ɓI쐬
			UnicodeString col_fnam = to_absolute_name(UserHighlight->ReadKeyStr(_T("ColorIniFile")));
			if (isExtWnd) {
				TExTxtViewer *xtv = dynamic_cast<TExTxtViewer *>(OwnerForm);
				if (xtv) {
					ColorDlg->ObjViewer = xtv->ExViewer;
					ColorDlg->FileName  = col_fnam;
					ColorDlg->ShowModal();
				}
			}
			else {
				ColorDlg->FileName = col_fnam;
				ColorDlg->ShowModal();
			}
		}
		Repaint(true);
	}
	//[\
	else if (USAME_TI(cmd, "ShowRuler")) {
		if (RulerBox) {
			RulerBox->Visible = SetToggleSw(ShowTextRuler, prm);
			Application->ProcessMessages();
			SetMetric(true);
		}
	}
	//sԍ\
	else if (USAME_TI(cmd, "ShowLineNo")) {
		SetToggleSw(ShowLineNo, prm);
		SetMetric(true);
	}
	//^u\
	else if (USAME_TI(cmd, "ShowTAB")) {
		SetToggleSw(ShowTAB, prm);
		Repaint(true);
	}
	//s\
	else if (USAME_TI(cmd, "ShowCR")) {
		SetToggleSw(ShowCR, prm);
		Repaint(true);
	}
	//Y[
	else if (contained_wd_i(_T("ZoomIn|ZoomOut"), cmd)) {
		int d_sz = std::min(prm.ToIntDef(1), 12);
		ViewBox->Font->Size =
			USAME_TI(cmd, "ZoomIn") ? std::min(ViewBox->Font->Size + d_sz, MAX_FNTZOOM_SZ)
									: std::max(ViewBox->Font->Size - d_sz, MIN_FNTZOOM_SZ);
		SetMetric(true);
	}
	else if (USAME_TI(cmd, "ZoomReset")) {
		ViewBox->Font->Size = useFontSize;
		SetMetric(true);
	}
	//tHgTCYύX
	else if (USAME_TI(cmd, "SetFontSize")) {
		bool x_sw = remove_top_s(prm, '^');
		if (!prm.IsEmpty()) {
			int f_sz = prm.ToIntDef(ViewBox->Font->Size);
			f_sz = std::max(std::min(f_sz, MAX_FNTZOOM_SZ), MIN_FNTZOOM_SZ);
			ViewBox->Font->Size = (x_sw && ViewBox->Font->Size==f_sz)? useFontSize : f_sz;
			SetMetric(true);
		}
	}
	else if (USAME_TI(cmd, "BoxSelMode")) {
		isBoxMode = !isBoxMode;
		isSelMode = isBoxMode;
	}
	else if (USAME_TI(cmd, "Highlight")) {
		SetToggleSw(Highlight, prm);
		Repaint(true);
	}
	//Č
	else if (contained_wd_i(_T("FindDown|FindUp"), cmd)) {
		if (!prm.IsEmpty()) {
			UnicodeString ptn;
			if (is_regex_slash(prm)) {
				isRegEx = true;
				ptn = exclude_top_end(prm);
			}
			else if (isMigemo)
				ptn = usr_Migemo->Query(prm);
			else
				ptn = TRegEx::Escape(prm);
			RegExPtn = chk_RegExPtn(ptn)? ptn : EmptyStr;
			FindWord = prm;
			Repaint(true);
		}

		if (USAME_TI(cmd, "FindDown"))
			SearchDown((isRegEx||isMigemo)? RegExPtn : FindWord, isCase, isRegEx||isMigemo, isBytes);
		else
			SearchUp((isRegEx||isMigemo)? RegExPtn : FindWord, isCase, isRegEx||isMigemo, isBytes);
	}
	//}[N
	else if (USAME_TI(cmd, "Mark"))
		MarkLine(cur_lno);
	else if (USAME_TI(cmd, "ClearMark")) {
		MarkListStr = EmptyStr;
		Repaint(true);
	}
	//}[N
	else if (USAME_TI(cmd, "FindMarkDown")) {
		TStringDynArray m_lst = split_strings_semicolon(MarkListStr);
		int f_lno = 0;
		for (int i=0; i<m_lst.Length; i++) {
			int lno = m_lst[i].ToIntDef(0);  if (lno==0) continue;
			if (lno>cur_lno) {
				if		(f_lno==0)  f_lno = lno;
				else if (lno<f_lno) f_lno = lno;
			}
		}
		LastFound = (f_lno>0);
		if (LastFound) {
			if (isBinary) ToAddrA((__int64)(f_lno - 1)*16); else ToLine(f_lno);
		}
		else if (!XCMD_IsBusy) beep_Warn();
	}
	else if (USAME_TI(cmd, "FindMarkUp")) {
		TStringDynArray m_lst = split_strings_semicolon(MarkListStr);
		int f_lno = 0;
		for (int i=0; i<m_lst.Length; i++) {
			int lno = m_lst[i].ToIntDef(0);  if (lno==0) continue;
			if (lno<cur_lno) {
				if		(f_lno==0)  f_lno = lno;
				else if (lno>f_lno) f_lno = lno;
			}
		}
		LastFound = (f_lno>0);
		if (LastFound) {
			if (isBinary) ToAddrA((__int64)(f_lno - 1)*16); else ToLine(f_lno);
		}
		else if (!XCMD_IsBusy) beep_Warn();
	}
	//-------------------------------
	//eLXg\݂̂̃R}h
	//-------------------------------
	else if (isText) {
		//HTMLeLXgϊ
		if (USAME_TI(cmd, "HtmlToText")) {
			SetToggleSw(isHtm2Txt, prm);
			AssignText();
		}
		//CSV/TSVŒ蒷\
		else if (USAME_TI(cmd, "FixedLen")) {
			int lmt = extract_int_def(prm);
			if (lmt>0) {
				ViewFixedLimit = std::max(lmt, 4);
				prm.USET_T("ON");
			}
			SetToggleSw(isFixedLen, prm);
			AssignText(NULL, cur_lno);
		}
		//r\
		else if (USAME_TI(cmd, "ShowRuby")) {
			SetToggleSw(ShowRuby, prm);
			AssignText();
		}
		//\[g
		else if (USAME_TI(cmd, "Sort")) {
			int xp = CurPos.x;
			int yi = get_LineRec(CurPos.y)->LineIdx;
			AssignText(NULL, cur_lno, USAME_TI(prm, "AO")? 1 : USAME_TI(prm, "DO")? -1 : 0);
			CurPos.x = xp;
			CurPos.y += yi;
			CurHchX  = cv_PosX_to_HchX(CurPos.x);
			UpdatePos();
		}
		//N
		else if (USAME_TI(cmd, "FindLinkDown"))
			SearchDown(LINK_MATCH_PTN, false, true);
		else if (USAME_TI(cmd, "FindLinkUp"))
			SearchUp(LINK_MATCH_PTN, false, true);
		else if (USAME_TI(cmd, "SetUserDefStr"))
			FuncListDlg->UserDefStr = prm;
		//URLJ
		else if (USAME_TI(cmd, "OpenURL")) {
			UnicodeString urlstr;
			if (!prm.IsEmpty()) {
				try {
					urlstr = TIdURI::URLEncode(prm, IndyTextEncoding_UTF8());
				}
				catch (Exception &e) {
					urlstr = EmptyStr;
				}
			}
			else {
				UnicodeString lbuf = get_SelText();
				if (lbuf.IsEmpty()) lbuf = get_CurLine(true);
				urlstr = extract_URL(lbuf);
			}
			if (urlstr.IsEmpty())
				GlobalErrMsg = LoadUsrMsg(USTR_NotFound, _T("URL"));
			else
				Execute_ex(urlstr);
		}
		//Web Ō
		else if (USAME_TI(cmd, "WebSearch")) {
			UnicodeString kw;
			if (USAME_TI(prm, "CB")) {
				std::unique_ptr<TStringList> sbuf(new TStringList());
				sbuf->Text  = Clipboard()->AsText;
				if (sbuf->Count>0) kw = sbuf->Strings[0];
			}
			else
				kw = get_tkn(def_if_empty(prm, get_SelText()), _T("\r\n"));

			if (kw.IsEmpty()) kw = inputbox_dir(get_WebSeaCaption().c_str(), _T("WebSearch"));
			if (!kw.IsEmpty()) {
				kw = System::Netencoding::TURLEncoding::URL->Encode(kw);
				UnicodeString urlstr = ReplaceStr(WebSeaUrl, "\\S", kw);
				if (urlstr.IsEmpty())
					GlobalErrMsg = LoadUsrMsg(USTR_NotFound, _T("URL"));
				else
					Execute_ex(urlstr);
			}
		}
		//J[\ʒu̒P̃wv
		else if (USAME_TI(cmd, "HelpCurWord")) {
			HtmlHelpKeyword(prm, GetCurWord(false));
		}
		//\
		else if (USAME_TI(cmd, "CharInfo")) {
			bool sw = CharInfoForm->Visible;
			CharInfoForm->Visible = SetToggleSw(sw, prm);
		}
		//CSV/TSVڂ̏Wv
		else if (USAME_TI(cmd, "CsvCalc")) {
			FileInfoDlg->isCalcItem  = true;
			FileInfoDlg->DataList	 = TxtBufList;
			FileInfoDlg->TopIsHeader = TopIsHeader;
			FileInfoDlg->CsvCol 	 = CsvCol;
			FileInfoDlg->ShowModal();
		}
		//CSV/TSVڂ̃Ot
		else if (USAME_TI(cmd, "CsvGraph")) {
			GraphForm->DataList    = TxtBufList;
			GraphForm->TopIsHeader = TopIsHeader;
			GraphForm->CsvCol	   = CsvCol;
			GraphForm->ShowModal();
		}
		//CSV/TSVR[h\
		else if (USAME_TI(cmd, "CsvRecord")) {
			bool sw = CsvRecForm->Visible;
			CsvRecForm->Visible = SetToggleSw(sw, prm);
		}
		//C[Wvr[
		else if (USAME_TI(cmd, "ImgPreview")) {
			UnicodeString fnam = GetCurImgFile();
			if (!GifViewer->Visible && !fnam.IsEmpty()) {
				GifViewer->Show();
				GifViewer->DrawImage(fnam);
				Application->MainForm->SetFocus();
			}
			else {
				if (fnam.IsEmpty() || SameText(GifViewer->FileName, fnam))
					GifViewer->Close();
				else
					GifViewer->DrawImage(fnam);
			}
		}
		//G[
		else if (contained_wd_i(_T("NextErr|PrevErr"), cmd)) {
			if (isLog) {
				UnicodeString ptn = "^.>([ECW]|(     [45]\\d{2})) .*";
				if (USAME_TI(cmd, "NextErr")) SearchDown(ptn, true, true); else SearchUp(ptn, true, true);
			}
		}
		//
		else if (contained_wd_i(_T("BitmapView|Inspector"), cmd))
			GlobalErrMsg = LoadUsrMsg(USTR_InvalidCmd);
		else handled = false;
	}
	//-------------------------------
	//oCî݂̃R}h
	//-------------------------------
	else if (isBinary) {
		//rbg}bvr[
		if (USAME_TI(cmd, "BitmapView")) {
			bool sw = BitmapForm->Visible;
			BitmapForm->Visible = SetToggleSw(sw, prm);
		}
		//CXyN^
		else if (USAME_TI(cmd, "Inspector")) {
			bool sw = InspectForm->Visible;
			InspectForm->Visible = SetToggleSw(sw, prm);
		}
		//
		else if (contained_wd_i(_T("HtmlToText|ShowRuby|FindLinkDown|FindLinkUp|OpenURL|CharInfo"), cmd))
			GlobalErrMsg = LoadUsrMsg(USTR_InvalidCmd);
		else handled = false;
	}
	else handled = false;

	SetSttInf();
	return handled;
}

//---------------------------------------------------------------------------
//eLXgrA[ŗp\ȃR}h?
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::IsCmdAvailable(UnicodeString cmd)
{
	cmd = get_CmdStr(cmd);

	//ʃEBhEŗL̔
	if (isExtWnd) {
		//L
		if (contained_wd_i(
			_T("AppList|BackViewHist|BinaryEdit|Calculator|ChangeCodePage|ChangeViewMode|ClipCopy|Close|")
			_T("FileEdit|FindText|IncSearch|NextFile|OptionDlg|PrevFile|RegExChecker|ReloadFile|SaveDump|")
			_T("SwitchSameName|SwitchSrcHdr|TagJump|TagJumpDirect|TagView|TagViewDirect"), cmd))
		{
			return true;
		}
		//
		if (contained_wd_i(
			_T("BitmapView|CharInfo|CsvCalc|CsvGraph|CsvRecord|Inspector|ImgPreview||")
			_T("ListFileInfo|ShowFileInfo "), cmd))
		{
			return false;
		}
	}

	//ʃR}h
	if (GetComCmdIndex(cmd)!=-1) return true;

	if (contained_wd_i(
		_T("BoxSelMode|ClearMark|FindDown|FindUp|FindMarkDown|FindMarkUp|Highlight|Mark|SetColor|SetFontSize|")
		_T("ShowCR|ShowLineNo|ShowRuler|ShowTAB|ZoomIn|ZoomOut|ZoomReset"), cmd))
	{
		return true;
	}

	//eLXg\݂̂̃R}h
	if (isText) {
		return(contained_wd_i(
			_T("CharInfo|CsvCalc|CsvGraph|CsvRecord|FindLinkDown|FindLinkUp|FixedLen|HelpCurWord|HtmlToText|ImgPreview|")
			_T("OpenURL|SetUserDefStr|ShowRuby|Sort|WebSearch"), cmd));
	}

	//oCî݂̃R}h
	if (isBinary) {
		return(contained_wd_i(_T("BitmapView|Inspector"), cmd));
	}

	return false;
}

//---------------------------------------------------------------------------
//[hŗL̋֎~R}hH
//---------------------------------------------------------------------------
bool __fastcall TTxtViewer::IsCmdInhibited(UnicodeString cmd)
{
	cmd = get_CmdStr(cmd);

	if (isBinary) {
		return(contained_wd_i(
			_T("ChangeCodePage|CharInfo|CsvCalc|CsvGraph|CsvRecord|FindLinkDown|FindLinkUp|FixedLen|")
			_T("HelpCurWord|HtmlToText|ImgPreview|OpenURL|SetUserDefStr|ShowRuby|Sort|WebSearch|")
			_T("FunctionList|UserDefList|MarkList|TagJump|TagJumpDirect|TagView|TagViewDirect"), cmd));
	}

	if (isText) {
		return(contained_wd_i(_T("BitmapView|Inspector|SaveDump"), cmd));
	}

	return false;
}
//---------------------------------------------------------------------------

